package com.example.nmgggzyspyder.spyder;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.Cfsnmgggzy;
import com.example.nmgggzyspyder.entity.Eedsnmgggzy;
import com.example.nmgggzyspyder.entity.Nmgggzy;
import com.example.nmgggzyspyder.service.FileIdsService;
import com.example.nmgggzyspyder.service.ImageIdsService;
import com.example.nmgggzyspyder.service.NmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.HttpResponse;
import kong.unirest.JsonNode;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.time.Duration;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.List;

@Component
public class CmsCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private NmgggzyService nmgggzyService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;


    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){

        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                if(j != 1){
                    try {
                        WebElement su = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[5]/div/a[last()]"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(1700);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
                for (int i = 2; i <= 16; i++) {
                    try {
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[4]/table/tbody/tr["+i+"]/td[2]/a"));
                        String title = elementTitle.getText();
                        System.out.println(title);
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[4]/table/tbody/tr["+i+"]/td[3]"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());


                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("ggzyjy.nmg.gov.cn");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Nmgggzy hhhtsnmgggzy = new Nmgggzy();
                                hhhtsnmgggzy.setId(md5idhref1);
                                hhhtsnmgggzy.setTitle(title);
                                hhhtsnmgggzy.setTime(time);
                                hhhtsnmgggzy.setUrl(href1);
                                hhhtsnmgggzy.setChannle(channle);
                                hhhtsnmgggzy.setContent("链接文章");
                                nmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(fileType == "" || fileType == null || fileType == "null"){
                                fileType = getFileTypeByUrl(href1);
                            }
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idStr = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idStr+"."+fileType,JsoupUtilsView.filePathCFS);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Nmgggzy hhhtsnmgggzy = new Nmgggzy();
                                        hhhtsnmgggzy.setId(md5id);
                                        hhhtsnmgggzy.setTitle(title);
                                        hhhtsnmgggzy.setTime(time);
                                        hhhtsnmgggzy.setUrl(title+md5idStr+"."+fileType);
                                        hhhtsnmgggzy.setChannle(channle);
                                        hhhtsnmgggzy.setContent("文件文章");
                                        nmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }
                        Nmgggzy nmgggzy = new Nmgggzy();
                        nmgggzy.setId(md5id);
                        nmgggzy.setTitle(title);
                        nmgggzy.setTime(time);
                        nmgggzy.setUrl(href1);
                        nmgggzy.setChannle(channle);
                        nmgggzyService.saveOrUpdate(nmgggzy);

                        try {
                            saveContent(href1);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }

    }

    public void zyxxPT(String url,int pageNum,String channle){

        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                if(j != 1){
                    try {
                        ///html/body/div[2]/div[2]/div/form/div[2]/div/a[last()]
                        WebElement su = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/form/div[2]/div/a[last()]"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(1700);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
                for (int i = 2; i <= 16; i++) {
                    try {
                        //   /html/body/div[2]/div[2]/div/form/div[1]/table/tbody/tr[2]/td[2]/a
                        //   /html/body/div[2]/div[2]/div/form/div[1]/table/tbody/tr[3]/td[2]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/form/div[1]/table/tbody/tr["+i+"]/td[2]/a"));
                        String title = elementTitle.getText();
                        System.out.println(title);
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        //   /html/body/div[2]/div[2]/div/form/div[1]/table/tbody/tr[2]/td[3]
                        //   /html/body/div[2]/div[2]/div/form/div[1]/table/tbody/tr[3]/td[3]
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/form/div[1]/table/tbody/tr["+i+"]/td[3]"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());


                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("ggzyjy.nmg.gov.cn");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Nmgggzy hhhtsnmgggzy = new Nmgggzy();
                                hhhtsnmgggzy.setId(md5idhref1);
                                hhhtsnmgggzy.setTitle(title);
                                hhhtsnmgggzy.setTime(time);
                                hhhtsnmgggzy.setUrl(href1);
                                hhhtsnmgggzy.setChannle(channle);
                                hhhtsnmgggzy.setContent("链接文章");
                                nmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(fileType == "" || fileType == null || fileType == "null"){
                                fileType = getFileTypeByUrl(href1);
                            }
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idStr = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idStr+"."+fileType,JsoupUtilsView.filePathCFS);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Nmgggzy hhhtsnmgggzy = new Nmgggzy();
                                        hhhtsnmgggzy.setId(md5id);
                                        hhhtsnmgggzy.setTitle(title);
                                        hhhtsnmgggzy.setTime(time);
                                        hhhtsnmgggzy.setUrl(href1);
                                        hhhtsnmgggzy.setChannle(channle);
                                        hhhtsnmgggzy.setContent("文件文章");
                                        nmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }
                        Nmgggzy nmgggzy = new Nmgggzy();
                        nmgggzy.setId(md5id);
                        nmgggzy.setTitle(title);
                        nmgggzy.setTime(time);
                        nmgggzy.setUrl(href1);
                        nmgggzy.setChannle(channle);
                        nmgggzyService.saveOrUpdate(nmgggzy);

                        try {
                            saveContent(href1);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }

    }


    public void zyxxDJGZ(String url,int pageNum,String channle){

        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                driver.navigate().refresh();
                try {
                    try {
                        WebElement su = driver.findElement(By.xpath("//*[@id=\"sideMenu\"]/div[2]/ul/li[1]/a"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(1700);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    /*try {
                        WebElement su = driver.findElement(By.xpath("//*[@id=\"content\"]/div/div/div[1]/span[2]/a"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(1700);
                    }catch (Exception e){
                        e.printStackTrace();
                    }*/
                }catch (Exception e){
                    e.printStackTrace();
                }

                //在id为kw的输入框当中输入内容
                WebElement kw = driver.findElement(By.className("el-input__inner"));
                Thread.sleep(1700);
                kw.clear();
                Thread.sleep(1700);
                kw.sendKeys(j+"");
                Actions action = new Actions(driver);
                action.sendKeys(Keys.RETURN).perform();
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(5700);
                for (int i = 1; i <= 15; i++) {
                    try {
                        WebElement elementTitle = driver.findElement(By.xpath("//*[@id=\"content\"]/div/div/div[2]/ul/li["+i+"]/div[1]/a"));
                        String title = elementTitle.getText();
                        System.out.println(title);
                        String time = null;
                        try {
                            WebElement elementTime = driver.findElement(By.xpath("//*[@id=\"content\"]/div/div/div[2]/ul/li["+i+"]/div[3]/div[2]/span"));
                            time = elementTime.getText();
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                        try {
                            if(time == null || time == ""){
                                //  //*[@id="content"]/div/div/div[2]/ul/li[1]/div[1]/a
                                //  //*[@id="content"]/div/div/div[2]/ul/li[10]/div[3]/div[2]/span
                                WebElement elementTime = driver.findElement(By.xpath("//*[@id=\"content\"]/div/div/div[2]/ul/li["+i+"]/div[2]/div[2]/span"));
                                time = elementTime.getText();
                            }
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                        elementTitle.click();
                        driver.switchTo().window((String) driver.getWindowHandles().toArray()[1]); // 切换到新窗口
                        String newPageLink = driver.getCurrentUrl();
                        String href1 =  newPageLink;
                        System.out.println(href1);
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(2700);
                        System.out.println("=======================");
                        System.out.println(newPageLink);
                        driver.close(); // 关闭新窗口
                        driver.switchTo().window((String) driver.getWindowHandles().toArray()[0]); // 切换回旧窗口
                        Nmgggzy nmgggzy = new Nmgggzy();
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        nmgggzy.setId(md5id);
                        nmgggzy.setTitle(title);
                        nmgggzy.setTime(time);
                        nmgggzy.setUrl(href1);
                        nmgggzy.setChannle(channle);
                        nmgggzyService.saveOrUpdate(nmgggzy);
                        try {
                            saveContentDJGZ(href1);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }

    public void zcfg(String url,int pageNum,int pageNum2,String channle){
        String oldchannle = channle;
        channle = channle + "/国家级";
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                if(j != 1){
                    try {
                        WebElement su = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/a[last()]"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(1700);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
                for (int i = 1; i <= 15; i++) {
                    try {
                        ///html/body/div[2]/div[2]/div[1]/div[4]/ul/li[1]/a
                        ///html/body/div[2]/div[2]/div[1]/div[4]/ul/li[2]/a
                        ///html/body/div[2]/div[2]/div[1]/div[4]/ul/li[15]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[1]/div[4]/ul/li["+i+"]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[1]/div[4]/ul/li["+i+"]/a/div[1]/p"));
                        String title = elementTimeTitle.getText();

                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[1]/div[4]/ul/li["+i+"]/a/div[2]/p"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        Nmgggzy nmgggzy = new Nmgggzy();
                        nmgggzy.setId(md5id);
                        nmgggzy.setTitle(title);
                        nmgggzy.setTime(time);
                        nmgggzy.setUrl(href1);
                        nmgggzy.setChannle(channle);
                        nmgggzyService.saveOrUpdate(nmgggzy);

                        try {
                            saveContent(href1);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
        zcfgZZQ(url,pageNum2,oldchannle);
    }

    public void zcfgOn(String url,int pageNum,String channle){
        String oldchannle = channle;
        channle = channle + "/国家级";
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                if(j != 1){
                    try {
                        WebElement su = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/a[last()]"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(1700);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
                for (int i = 1; i <= 15; i++) {
                    try {
                        ///html/body/div[2]/div[2]/div[1]/div[4]/ul/li[1]/a
                        ///html/body/div[2]/div[2]/div[1]/div[4]/ul/li[2]/a
                        ///html/body/div[2]/div[2]/div[1]/div[4]/ul/li[15]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[1]/div[4]/ul/li["+i+"]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[1]/div[4]/ul/li["+i+"]/a/div[1]/p"));
                        String title = elementTimeTitle.getText();

                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[1]/div[4]/ul/li["+i+"]/a/div[2]/p"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        Nmgggzy nmgggzy = new Nmgggzy();
                        nmgggzy.setId(md5id);
                        nmgggzy.setTitle(title);
                        nmgggzy.setTime(time);
                        nmgggzy.setUrl(href1);
                        nmgggzy.setChannle(channle);
                        nmgggzyService.saveOrUpdate(nmgggzy);

                        try {
                            saveContent(href1);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }

    public void zcfgZZQ(String url,int pageNum2,String channle){
        channle = channle + "/自治区级";
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            WebElement zcfgForm = driver.findElement(By.xpath("//*[@id=\"zcfgForm\"]/div/div/a[2]"));
            zcfgForm.click();
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum2; j++) {
                if(j != 1){
                    try {
                        WebElement su = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/a[last()]"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(1700);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
                for (int i = 1; i <= 15; i++) {
                    try {
                        ///html/body/div[2]/div[2]/div[1]/div[4]/ul/li[1]/a
                        ///html/body/div[2]/div[2]/div[1]/div[4]/ul/li[2]/a
                        ///html/body/div[2]/div[2]/div[1]/div[4]/ul/li[15]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[1]/div[4]/ul/li["+i+"]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[1]/div[4]/ul/li["+i+"]/a/div[1]/p"));
                        String title = elementTimeTitle.getText();

                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[1]/div[4]/ul/li["+i+"]/a/div[2]/p"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        Nmgggzy nmgggzy = new Nmgggzy();
                        nmgggzy.setId(md5id);
                        nmgggzy.setTitle(title);
                        nmgggzy.setTime(time);
                        nmgggzy.setUrl(href1);
                        nmgggzy.setChannle(channle);
                        nmgggzyService.saveOrUpdate(nmgggzy);

                        try {
                            saveContent(href1);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }

    }

    public void spyderJSON(){

        String channle = "优化营商环境优化营商环境";

        for (int i = 1; i < 12; i++) {
            HttpResponse<JsonNode> jsonNodeHttpResponse = Unirest.post("https://ggzyjy.nmg.gov.cn/nmgggfwpt-center-web/admin/dongtai/queryDongTai")
                    .header("Accept", "application/json, text/javascript, */*; q=0.01")
                    .header("Cookie", "JSESSIONID=f19286c9-a145-49f4-9a63-c0ca3e640d73; _trs_uv=lkfgger5_4643_fewf; _gscu_1113760881=94161027d5oe5x10; UM_distinctid=18d67ab21db1ed-0497ade3a0e296-4c657b58-13c680-18d67ab21dc6d0; _gscbrs_1113760881=1")
                    .queryString("isBaoSong", "0")
                    .queryString("type", "3")
                    .queryString("title", "")
                    .queryString("newsStatus", "")
                    .queryString("page", i)
                    .queryString("rows", "10")
                    .asJson();

            if(!ObjectUtils.isEmpty(jsonNodeHttpResponse)){
                JsonNode body = jsonNodeHttpResponse.getBody();
                if(!ObjectUtils.isEmpty(body)){
                    String json = body.toString();
                    if(!ObjectUtils.isEmpty(json)){
                        JSONObject jsonObject = JSON.parseObject(json);
                        if(!ObjectUtils.isEmpty(jsonObject)){
                            Object rowsJSON = jsonObject.get("rows");
                            if(!ObjectUtils.isEmpty(rowsJSON)){
                                String stringRowsJSON = rowsJSON.toString();
                                JSONArray parseArray = JSONArray.parseArray(stringRowsJSON);
                                for (Object objParseArray : parseArray) {
                                    if(!ObjectUtils.isEmpty(objParseArray)){
                                        String string = objParseArray.toString();
                                        JSONObject jsonObjectS = JSON.parseObject(string);
                                        if(!ObjectUtils.isEmpty(jsonObjectS)){
                                            String title = jsonObjectS.get("title")+"";
                                            String content = jsonObjectS.get("content")+"";
                                            String publishTime = jsonObjectS.get("publishTime")+"";
                                            System.out.println(title);
                                            System.out.println(publishTime);
                                            System.out.println(content);
                                            if(!ObjectUtils.isEmpty(publishTime) && publishTime != null && publishTime != ""){
                                                try {
                                                    publishTime = convertToDateString(publishTime);
                                                }catch (Exception e){
                                                    e.printStackTrace();
                                                }
                                            }
                                            String idStr = title + title + publishTime + channle;
                                            String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                                            Nmgggzy nmgggzy = new Nmgggzy();
                                            nmgggzy.setId(md5id);
                                            nmgggzy.setTitle(title);
                                            nmgggzy.setTime(publishTime);
                                            nmgggzy.setContent(content);
                                            nmgggzy.setChannle(channle);
                                            nmgggzyService.saveOrUpdate(nmgggzy);
                                            zyxxContHTML(nmgggzy);
                                        }

                                    }
                                }
                            }
                        }
                    }
                }
            }
        }



    }

    public  String convertToDateString(String timestampInMilliseconds) {
        // 将毫秒时间戳转换为Instant对象
        Instant instant = Instant.ofEpochMilli(Long.parseLong(timestampInMilliseconds));

        // 将Instant对象转换为中国时区的LocalDateTime对象（如果需要特定时区，替换ZoneId.systemDefault()）
        LocalDateTime localDateTime = instant.atZone(ZoneId.systemDefault()).toLocalDateTime();

        // 创建一个DateTimeFormatter来格式化日期时间
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

        // 格式化为字符串
        return localDateTime.format(formatter);
    }

    public void dangjiangongzuuo(String url,int pageNum,String channle){

        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                if(j != 1){
                    try {
                        WebElement su = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[5]/div/a[last()]"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(1700);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
                for (int i = 2; i <= 16; i++) {
                    try {
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[4]/table/tbody/tr["+i+"]/td[2]/a"));
                        String title = elementTitle.getText();
                        System.out.println(title);
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[4]/table/tbody/tr["+i+"]/td[3]"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        Nmgggzy nmgggzy = new Nmgggzy();
                        nmgggzy.setId(md5id);
                        nmgggzy.setTitle(title);
                        nmgggzy.setTime(time);
                        nmgggzy.setUrl(href1);
                        nmgggzy.setChannle(channle);
                        nmgggzyService.saveOrUpdate(nmgggzy);

                        try {
                            saveContent(href1);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }

    }

    public void saveContent(String url){
        QueryWrapper<Nmgggzy> queryWrapper = new QueryWrapper<Nmgggzy>();
        queryWrapper.eq("url", url);
        List<Nmgggzy> list = nmgggzyService.list(queryWrapper);
        for (Nmgggzy nmgggzy : list) {
            zyxxCont(nmgggzy);
        }
    }

    public void saveContentAll(String channle){
        QueryWrapper<Nmgggzy> queryWrapper = new QueryWrapper<Nmgggzy>();
        queryWrapper.eq("channle", channle);
        List<Nmgggzy> list = nmgggzyService.list(queryWrapper);
        for (Nmgggzy nmgggzy : list) {
            zyxxCont(nmgggzy);
        }
    }

    public void saveContentAllAA(){
        List<Nmgggzy> list = nmgggzyService.list();
        for (Nmgggzy nmgggzy : list) {
            zyxxCont(nmgggzy);
        }
    }


    public void zyxxCont(Nmgggzy nmgggzy){
        try {
            Document parse = Jsoup.parse(new URL(nmgggzy.getUrl()),60000);//设置60s超时
            String baseUrl = jsoupUtils.getBaseUrl(nmgggzy.getUrl());
            Document document = jsoupUtils.setUrl(parse, baseUrl);
            String HTML = "";
            Elements elementsByClass = document.getElementsByClass("container");
            String html1 = elementsByClass.html();
            Document parse1 = Jsoup.parse(html1);
            try {
                parse1.getElementsByClass("title").remove();
            }catch (Exception e){
                e.printStackTrace();
            }
            try {
                parse1.getElementsByClass("tip").remove();
            }catch (Exception e){
                e.printStackTrace();
            }
            try {
                parse1.getElementsByClass("location").remove();
            }catch (Exception e){
                e.printStackTrace();
            }
            try {
                parse1.getElementsByClass("detail_t").remove();
            }catch (Exception e){
                e.printStackTrace();
            }

            try {
                parse1.getElementsByClass("kdg").remove();
            }catch (Exception e){
                e.printStackTrace();
            }


            HTML = parse1.html();
            System.out.println("=======================");
            System.out.println(HTML);
            FileStrList fileStrList = jsoupUtilsView.rexStringHtml(HTML);
            String html = fileStrList.getHtml();
            nmgggzy.setContent(html);
            System.out.println("=======================");
            System.out.println(html);
            fileStrList.setHtml(html);
            List<String> fileList = fileStrList.getFileList();
            String fileIds = "";
            for (String s : fileList) {
                fileIds += s +",";
            }
            if(fileIds != "" && fileIds != null){
                nmgggzy.setFileIds(fileIds);
            }
            List<String> imgList = fileStrList.getImgList();
            String imgIds = "";
            for (String s : imgList) {
                imgIds += s +",";
            }
            if(imgIds != "" && imgIds != null){
                nmgggzy.setImageIds(imgIds);
            }
            System.out.println("+++++++++++++++++++++++++++++++++++");
            System.out.println(fileStrList.getHtml());
            nmgggzyService.updateById(nmgggzy);
        }catch (Exception e){
        }
    }

    public void zyxxContHTML(Nmgggzy nmgggzy){
        try {
            String contentHTML = nmgggzy.getContent();
            Document parse = Jsoup.parse(contentHTML);//设置60s超时
            String baseUrl = "https://ggzyjy.nmg.gov.cn/";
            Document document = jsoupUtils.setUrl(parse, baseUrl);
            contentHTML = document.html();
            System.out.println("=======================");
            FileStrList fileStrList = jsoupUtilsView.rexStringHtml(contentHTML);
            String html = fileStrList.getHtml();
            nmgggzy.setContent(html);
            System.out.println("=======================");
            System.out.println(html);
            fileStrList.setHtml(html);
            List<String> fileList = fileStrList.getFileList();
            String fileIds = "";
            for (String s : fileList) {
                fileIds += s +",";
            }
            if(fileIds != "" && fileIds != null){
                nmgggzy.setFileIds(fileIds);
            }
            List<String> imgList = fileStrList.getImgList();
            String imgIds = "";
            for (String s : imgList) {
                imgIds += s +",";
            }
            if(imgIds != "" && imgIds != null){
                nmgggzy.setImageIds(imgIds);
            }
            System.out.println("+++++++++++++++++++++++++++++++++++");
            System.out.println(fileStrList.getHtml());
            nmgggzyService.updateById(nmgggzy);
        }catch (Exception e){
        }
    }

    private void saveContentDJGZ(String url) {
        QueryWrapper<Nmgggzy> queryWrapper = new QueryWrapper<Nmgggzy>();
        queryWrapper.eq("url", url);
        List<Nmgggzy> list = nmgggzyService.list(queryWrapper);
        for (Nmgggzy nmgggzy : list) {
            zyxxContDJGZ(nmgggzy);
        }
    }

    public void zyxxContDJGZ(Nmgggzy nmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(nmgggzy.getUrl());
                String pageSource = driver.getPageSource();
                System.out.println(pageSource);
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(1700);
                Document parse = Jsoup.parse(pageSource);//设置60s超时
                String baseUrl = jsoupUtils.getBaseUrl(nmgggzy.getUrl());
                parse = jsoupUtils.setUrl(parse, baseUrl);
                Elements detail_contect = parse.getElementsByClass("conTxt");
                String HTML = "";
                for (Element element : detail_contect) {
                    HTML += element.html();
                }
                System.out.println("detail_contect.html()=="+detail_contect.html());
                System.out.println("=======================");
                System.out.println(HTML);
                FileStrList fileStrList = jsoupUtilsView.rexStringHtml(HTML);
                String html = fileStrList.getHtml();
                nmgggzy.setContent(html);
                System.out.println("=======================");
                System.out.println(html);
                fileStrList.setHtml(html);
                List<String> fileList = fileStrList.getFileList();
                String fileIds = "";
                for (String s : fileList) {
                    fileIds += s +",";
                }
                if(fileIds != "" && fileIds != null){
                    nmgggzy.setFileIds(fileIds);
                }
                List<String> imgList = fileStrList.getImgList();
                String imgIds = "";
                for (String s : imgList) {
                    imgIds += s +",";
                }
                if(imgIds != "" && imgIds != null){
                    nmgggzy.setImageIds(imgIds);
                }
                System.out.println("+++++++++++++++++++++++++++++++++++");
                System.out.println(fileStrList.getHtml());
                nmgggzyService.updateById(nmgggzy);

            }catch (Exception e){
                e.printStackTrace();
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }


        }catch (Exception e){
        }
    }




    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }
    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }
    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
}
