package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.Eedsnmgggzy;
import com.example.nmgggzyspyder.entity.Hhhtsnmgggzy;
import com.example.nmgggzyspyder.entity.Nmgggzy;
import com.example.nmgggzyspyder.service.EedsnmgggzyService;
import com.example.nmgggzyspyder.service.HhhtsnmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class CmsEEDSCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private EedsnmgggzyService eedsnmgggzyService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;


    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            for (int j = 1; j <= pageNum; j++) {
                driver.get(url+j);
                driver.navigate().refresh();
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(1700);
                for (int i = 1; i <= 16; i++) {
                    try {
                        ////*[@id="main"]/div[2]/table/tbody/tr/td[3]/table/tbody/tr[3]/td/div/table/tbody/tr/td/table/tbody/tr[1]/td[2]/a
                        ////*[@id="main"]/div[2]/table/tbody/tr/td[3]/table/tbody/tr[3]/td/div/table/tbody/tr/td/table/tbody/tr[16]/td[2]/a
                                                     ///html/body/div[4]/div[2]/table/tbody/tr/td[3]/table/tbody/tr[3]/td/div/table/tbody/tr/td/table/tbody/tr[2]/td[2]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[4]/div[2]/table/tbody/tr/td[3]/table/tbody/tr[3]/td/div/table/tbody/tr/td/table/tbody/tr["+i+"]/td[2]/a"));

                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        String title = elementTitle.getText();
                        System.out.println(title);

                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[4]/div[2]/table/tbody/tr/td[3]/table/tbody/tr[3]/td/div/table/tbody/tr/td/table/tbody/tr["+i+"]/td[3]"));
                        String time = elementTime.getText();
                        time = time.replace("[","");
                        time = time.replace("]","");
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());

                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("www.ordosggzyjy.org.cn");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Eedsnmgggzy hhhtsnmgggzy = new Eedsnmgggzy();
                                hhhtsnmgggzy.setId(md5idhref1);
                                hhhtsnmgggzy.setTitle(title);
                                hhhtsnmgggzy.setTime(time);
                                hhhtsnmgggzy.setUrl(href1);
                                hhhtsnmgggzy.setChannle(channle);
                                hhhtsnmgggzy.setContent("链接文章");
                                eedsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(fileType == "" || fileType == null || fileType == "null"){
                                fileType = getFileTypeByUrl(href1);
                            }
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idStr = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idStr+"."+fileType,JsoupUtilsView.filePathEEDS);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Eedsnmgggzy hhhtsnmgggzy = new Eedsnmgggzy();
                                        hhhtsnmgggzy.setId(md5id);
                                        hhhtsnmgggzy.setTitle(title);
                                        hhhtsnmgggzy.setTime(time);
                                        hhhtsnmgggzy.setUrl(title+md5idStr+"."+fileType);
                                        hhhtsnmgggzy.setChannle(channle);
                                        hhhtsnmgggzy.setContent("文件文章");
                                        eedsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }
                        Eedsnmgggzy hhhtsnmgggzy = new Eedsnmgggzy();
                        hhhtsnmgggzy.setId(md5id);
                        hhhtsnmgggzy.setTitle(title);
                        hhhtsnmgggzy.setTime(time);
                        hhhtsnmgggzy.setUrl(href1);
                        hhhtsnmgggzy.setChannle(channle);
                        eedsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }


    public void saveContent(String url){
        QueryWrapper<Eedsnmgggzy> queryWrapper = new QueryWrapper<Eedsnmgggzy>();
        queryWrapper.eq("url", url);

        List<Eedsnmgggzy> list = eedsnmgggzyService.list(queryWrapper);
        for (Eedsnmgggzy hhhtsnmgggzy : list) {
            zyxxCont(hhhtsnmgggzy);
        }
    }

    public void zyxxCont(Eedsnmgggzy hhhtsnmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(hhhtsnmgggzy.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {

                    String baseUrl = jsoupUtils.getBaseUrl(hhhtsnmgggzy.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    Element detail_contect = document.getElementById("tblInfo");
                    try {
                        document.getElementById("tdTitle").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    try {
                        document.getElementsByClass("bd1").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                    String HTML = detail_contect.html();
                    System.out.println("=======================");
                    System.out.println(HTML);
                    FileStrList fileStrList = jsoupUtilsView.rexStringHtmlEEDS(HTML);
                    String html = fileStrList.getHtml();
                    hhhtsnmgggzy.setContent(html);
                    System.out.println("=======================");
                    System.out.println(html);
                    fileStrList.setHtml(html);
                    List<String> fileList = fileStrList.getFileList();
                    String fileIds = "";
                    for (String s : fileList) {
                        fileIds += s +",";
                    }
                    if(fileIds != "" && fileIds != null){
                        hhhtsnmgggzy.setFileIds(fileIds);
                    }
                    List<String> imgList = fileStrList.getImgList();
                    String imgIds = "";
                    for (String s : imgList) {
                        imgIds += s +",";
                    }
                    if(imgIds != "" && imgIds != null){
                        hhhtsnmgggzy.setImageIds(imgIds);
                    }
                    System.out.println("+++++++++++++++++++++++++++++++++++");
                    System.out.println(fileStrList.getHtml());
                    eedsnmgggzyService.updateById(hhhtsnmgggzy);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }
    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }
    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }


}
