package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.Hhhtsnmgggzy;
import com.example.nmgggzyspyder.entity.Mzlmgggzy;
import com.example.nmgggzyspyder.service.HhhtsnmgggzyService;
import com.example.nmgggzyspyder.service.MzlmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class CmsMALCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;


    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private MzlmgggzyService mzlmgggzyService;


    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,String pageUrl,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                if(j > 1){
                    driver.get(pageUrl+j+".htm");
                    driver.navigate().refresh();
                }
                if(j <= 1){
                    driver.get(url);
                    driver.navigate().refresh();
                }
                for (int i = 1; i <= 15; i++) {
                    try {
                        //   /html/body/div[2]/div[1]/div[2]/form/ul/li[1]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[1]/div[2]/form/ul/li["+i+"]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div[1]/div[2]/form/ul/li["+i+"]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        ///html/body/div[2]/div[1]/div[2]/form/ul/li[1]/span
                        ///html/body/div[2]/div[1]/div[2]/form/ul/li[2]/span
                        ///html/body/div[2]/div[1]/div[2]/form/ul/li[15]/a
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[1]/div[2]/form/ul/li["+i+"]/span"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("www.mzlggzy.org.cn");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                                mzlmgggzy.setId(md5idhref1);
                                mzlmgggzy.setTitle(title);
                                mzlmgggzy.setTime(time);
                                mzlmgggzy.setUrl(href1);
                                mzlmgggzy.setChannle(channle);
                                mzlmgggzy.setContent("链接文章");
                                mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idStr = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idStr+"."+fileType,JsoupUtilsView.filePathMZL);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                                        mzlmgggzy.setId(md5id);
                                        mzlmgggzy.setTitle(title);
                                        mzlmgggzy.setTime(time);
                                        mzlmgggzy.setUrl(title+md5idStr+"."+fileType);
                                        mzlmgggzy.setChannle(channle);
                                        mzlmgggzy.setContent("文件文章");
                                        mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }
                        Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                        mzlmgggzy.setId(md5id);
                        mzlmgggzy.setTitle(title);
                        mzlmgggzy.setTime(time);
                        mzlmgggzy.setUrl(href1);
                        mzlmgggzy.setChannle(channle);
                        mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }


    public void zwgg(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.id("data-page-txt"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.cssSelector("#pager > div.m-pagination-jump > div > button"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                    Thread.sleep(2700);
                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 0; i <= 30; i++) {
                    try {
                        ///html/body/div[2]/div[2]/div[2]/ul/li[1]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/ul/li["+i+"]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/ul/li["+i+"]/a/span[1]"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/ul/li["+i+"]/a/span[2]"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());

                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("www.mzlggzy.org.cn");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                                mzlmgggzy.setId(md5idhref1);
                                mzlmgggzy.setTitle(title);
                                mzlmgggzy.setTime(time);
                                mzlmgggzy.setUrl(href1);
                                mzlmgggzy.setChannle(channle);
                                mzlmgggzy.setContent("链接文章");
                                mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(fileType == "" || fileType == null || fileType == "null"){
                                fileType = getFileTypeByUrl(href1);
                            }
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idStr = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idStr+"."+fileType,JsoupUtilsView.filePathCFS);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                                        mzlmgggzy.setId(md5id);
                                        mzlmgggzy.setTitle(title);
                                        mzlmgggzy.setTime(time);
                                        mzlmgggzy.setUrl(href1);
                                        mzlmgggzy.setChannle(channle);
                                        mzlmgggzy.setContent("文件文章");
                                        mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }

                        Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                        mzlmgggzy.setId(md5id);
                        mzlmgggzy.setTitle(title);
                        mzlmgggzy.setTime(time);
                        mzlmgggzy.setUrl(href1);
                        mzlmgggzy.setChannle(channle);
                        mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }

    }
    public void zwggIP(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                try {
                    if(j == 1){
                        WebElement su = driver.findElement(By.xpath("/html/body/div[3]/div/div[2]/div[2]/div[3]/ul/li[1]/a"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(2700);
                    }
                    if(j == 2){
                        WebElement su = driver.findElement(By.xpath("/html/body/div[3]/div/div[2]/div[2]/div[3]/ul/li[2]/a"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(2700);
                    }
                    if(j == 3){
                        WebElement su = driver.findElement(By.xpath("/html/body/div[3]/div/div[2]/div[2]/div[3]/ul/li[3]/a"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(2700);
                    }
                    if(j == 4){
                        WebElement su = driver.findElement(By.xpath("/html/body/div[3]/div/div[2]/div[2]/div[3]/ul/li[4]/a"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(2700);
                    }

                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 0; i <= 30; i++) {
                    try {
                        // /html/body/div[3]/div/div[2]/div[2]/div[2]/ul[2]/li[1]/a
                        // /html/body/div[3]/div/div[2]/div[2]/div[2]/ul[2]/li[2]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[3]/div/div[2]/div[2]/div[2]/ul[2]/li["+i+"]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[3]/div/div[2]/div[2]/div[2]/ul[2]/li["+i+"]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[3]/div/div[2]/div[2]/div[2]/ul[2]/li["+i+"]/div"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());

                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("42.123.92.182");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                                mzlmgggzy.setId(md5idhref1);
                                mzlmgggzy.setTitle(title);
                                mzlmgggzy.setTime(time);
                                mzlmgggzy.setUrl(href1);
                                mzlmgggzy.setChannle(channle);
                                mzlmgggzy.setContent("链接文章");
                                mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(fileType == "" || fileType == null || fileType == "null"){
                                fileType = getFileTypeByUrl(href1);
                            }
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idStr = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idStr+"."+fileType,JsoupUtilsView.filePathCFS);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                                        mzlmgggzy.setId(md5id);
                                        mzlmgggzy.setTitle(title);
                                        mzlmgggzy.setTime(time);
                                        mzlmgggzy.setUrl(href1);
                                        mzlmgggzy.setChannle(channle);
                                        mzlmgggzy.setContent("文件文章");
                                        mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }

                        Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                        mzlmgggzy.setId(md5id);
                        mzlmgggzy.setTitle(title);
                        mzlmgggzy.setTime(time);
                        mzlmgggzy.setUrl(href1);
                        mzlmgggzy.setChannle(channle);
                        mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContentIp(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }

    }


    public void zwggZWDT(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.className("zxfinput"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.className("zxfokbtn"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                    Thread.sleep(2700);
                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 1; i <= 15; i++) {
                    try {
                        //   /html/body/div[1]/div[2]/div[2]/div[2]/ul/li[1]/a
                        //   //*[@id="list"]/li[15]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[1]/div[2]/div[2]/div[2]/ul/li["+i+"]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[1]/div[2]/div[2]/div[2]/ul/li["+i+"]/a/span[1]"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        //  /html/body/div[1]/div[2]/div[2]/div[2]/ul/li[1]/a/span[2]
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[1]/div[2]/div[2]/div[2]/ul/li["+i+"]/a/span[2]"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());

                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("ggzy.huhhot.gov.cn");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                                mzlmgggzy.setId(md5idhref1);
                                mzlmgggzy.setTitle(title);
                                mzlmgggzy.setTime(time);
                                mzlmgggzy.setUrl(href1);
                                mzlmgggzy.setChannle(channle);
                                mzlmgggzy.setContent("链接文章");
                                mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(fileType == "" || fileType == null || fileType == "null"){
                                fileType = getFileTypeByUrl(href1);
                            }
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idStr = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idStr+"."+fileType,JsoupUtilsView.filePathCFS);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                                        mzlmgggzy.setId(md5id);
                                        mzlmgggzy.setTitle(title);
                                        mzlmgggzy.setTime(time);
                                        mzlmgggzy.setUrl(href1);
                                        mzlmgggzy.setChannle(channle);
                                        mzlmgggzy.setContent("文件文章");
                                        mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }

                        Mzlmgggzy mzlmgggzy = new Mzlmgggzy();
                        mzlmgggzy.setId(md5id);
                        mzlmgggzy.setTitle(title);
                        mzlmgggzy.setTime(time);
                        mzlmgggzy.setUrl(href1);
                        mzlmgggzy.setChannle(channle);
                        mzlmgggzyService.saveOrUpdate(mzlmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }

    }



    private void saveContentIp(String url) {
        QueryWrapper<Mzlmgggzy> queryWrapper = new QueryWrapper<Mzlmgggzy>();
        queryWrapper.eq("url", url);

        List<Mzlmgggzy> list = mzlmgggzyService.list(queryWrapper);
        for (Mzlmgggzy mzlmgggzy : list) {
            zyxxContIP(mzlmgggzy);
        }
    }


    public void saveContent(String url){
        QueryWrapper<Mzlmgggzy> queryWrapper = new QueryWrapper<Mzlmgggzy>();
        queryWrapper.eq("url", url);

        List<Mzlmgggzy> list = mzlmgggzyService.list(queryWrapper);
        for (Mzlmgggzy mzlmgggzy : list) {
            zyxxCont(mzlmgggzy);
        }
    }

    public void zyxxCont(Mzlmgggzy mzlmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(mzlmgggzy.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {
                    String baseUrl = jsoupUtils.getBaseUrlHHHT(mzlmgggzy.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    Elements detail_contect = document.getElementsByClass("detail-con1");
                    String HTML = detail_contect.html();
                    System.out.println("detail_contect.html()=="+detail_contect.html());
                    if(detail_contect.size() <= 0){
                        Elements detail_contectCC = document.getElementsByClass("article-area clearfix");
                        HTML = detail_contectCC.html();
                        System.out.println("detail_contectCC.html()=="+detail_contectCC.html());
                        if(detail_contectCC.size() <= 0){
                            Elements detail_contectCCCC = document.getElementsByClass("news-body mt20");
                            HTML = detail_contectCCCC.html();
                            System.out.println("detail_contectCCCC.html()=="+detail_contectCCCC.html());
                            if(detail_contectCCCC.size() > 0){
                                Elements detail_contectmt20 = document.getElementsByClass("mt20");
                                HTML += detail_contectmt20.html();
                                System.out.println("detail_contectCCCC.html()=="+detail_contectCCCC.html());
                            }

                        }

                    }
                    System.out.println("=======================");
                    System.out.println(HTML);
                    FileStrList fileStrList = jsoupUtilsView.rexStringHtmlMZT(HTML);
                    String html = fileStrList.getHtml();
                    mzlmgggzy.setContent(html);
                    System.out.println("=======================");
                    System.out.println(html);
                    fileStrList.setHtml(html);
                    List<String> fileList = fileStrList.getFileList();
                    String fileIds = "";
                    for (String s : fileList) {
                        fileIds += s +",";
                    }
                    if(fileIds != "" && fileIds != null){
                        mzlmgggzy.setFileIds(fileIds);
                    }
                    List<String> imgList = fileStrList.getImgList();
                    String imgIds = "";
                    for (String s : imgList) {
                        imgIds += s +",";
                    }
                    if(imgIds != "" && imgIds != null){
                        mzlmgggzy.setImageIds(imgIds);
                    }
                    System.out.println("+++++++++++++++++++++++++++++++++++");
                    System.out.println(fileStrList.getHtml());
                    mzlmgggzyService.updateById(mzlmgggzy);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }
    public void zyxxContIP(Mzlmgggzy mzlmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(mzlmgggzy.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {
                    String baseUrl = jsoupUtils.getBaseUrlHHHT(mzlmgggzy.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    Elements detail_contect = document.getElementsByClass("news-body");
                    String HTML = detail_contect.html();
                    try {
                        Elements detail_contect2 = document.getElementsByClass("info-sec-tit");
                         HTML += detail_contect2.html();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    try {
                        Elements detail_contect3 = document.getElementsByClass("annex-list");
                         HTML += detail_contect3.html();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    System.out.println("=======================");
                    System.out.println(HTML);
                    FileStrList fileStrList = jsoupUtilsView.rexStringHtmlHHHT(HTML);
                    String html = fileStrList.getHtml();
                    mzlmgggzy.setContent(html);
                    System.out.println("=======================");
                    System.out.println(html);
                    fileStrList.setHtml(html);
                    List<String> fileList = fileStrList.getFileList();
                    String fileIds = "";
                    for (String s : fileList) {
                        fileIds += s +",";
                    }
                    if(fileIds != "" && fileIds != null){
                        mzlmgggzy.setFileIds(fileIds);
                    }
                    List<String> imgList = fileStrList.getImgList();
                    String imgIds = "";
                    for (String s : imgList) {
                        imgIds += s +",";
                    }
                    if(imgIds != "" && imgIds != null){
                        mzlmgggzy.setImageIds(imgIds);
                    }
                    System.out.println("+++++++++++++++++++++++++++++++++++");
                    System.out.println(fileStrList.getHtml());
                    mzlmgggzyService.updateById(mzlmgggzy);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }

    private String getFileType(String text) {
        int docId = text.indexOf("docId");
        if(docId >= 0){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println("urlStr====="+urlStr);
            System.out.println("fileName====="+fileName);
            System.out.println("savePath====="+savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

}
