package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.Hlbenmgggzy;
import com.example.nmgggzyspyder.entity.Tlsnmgggzy;
import com.example.nmgggzyspyder.entity.Xamnmgggzy;
import com.example.nmgggzyspyder.service.TlsnmgggzyService;
import com.example.nmgggzyspyder.service.XamnmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class CmsXAMrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private XamnmgggzyService xamnmgggzyService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,String baseUrl,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);

            for (int j = 1; j <= pageNum; j++) {
                new WebDriverWait(driver, Duration.ofSeconds(5));
                if(j > 1){
                    driver.get(baseUrl+j+".html");
                    driver.navigate().refresh();
                }
                if(j <= 1){
                    driver.get(url);
                    driver.navigate().refresh();
                }
                for (int i = 1; i <= 20; i++) {
                    try {
                        ///html/body/div[2]/div[2]/div[2]/div[2]/ul/li[1]/a
                        ///html/body/div[2]/div[2]/div[2]/div[2]/ul/li[14]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div[2]/ul/li["+i+"]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div[2]/ul/li["+i+"]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);

                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div[2]/ul/li["+i+"]/span"));
                        String time = elementTime.getText();
                        ///html/body/div[2]/div[2]/div[2]/div[2]/ul/li[16]/a
                        // /html/body/div[2]/div[2]/div[2]/div[2]/ul/li[1]/a
                        System.out.println(time);

                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());

                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("www.xamggzyjyzx.org.cn");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Xamnmgggzy hhhtsnmgggzy = new Xamnmgggzy();
                                hhhtsnmgggzy.setId(md5idhref1);
                                hhhtsnmgggzy.setTitle(title);
                                hhhtsnmgggzy.setTime(time);
                                hhhtsnmgggzy.setUrl(href1);
                                hhhtsnmgggzy.setChannle(channle);
                                hhhtsnmgggzy.setContent("链接文章");
                                xamnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(fileType == "" || fileType == null || fileType == "null"){
                                fileType = getFileTypeByUrl(href1);
                            }
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idDow = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idDow+"."+fileType,JsoupUtilsView.filePathXAM);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Xamnmgggzy hhhtsnmgggzy = new Xamnmgggzy();
                                        hhhtsnmgggzy.setId(md5idDow);
                                        hhhtsnmgggzy.setTitle(title);
                                        hhhtsnmgggzy.setTime(time);
                                        hhhtsnmgggzy.setUrl(title+md5idDow+"."+fileType);
                                        hhhtsnmgggzy.setChannle(channle);
                                        hhhtsnmgggzy.setContent("文件文章");
                                        xamnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }
                        Xamnmgggzy hhhtsnmgggzy = new Xamnmgggzy();
                        hhhtsnmgggzy.setId(md5id);
                        hhhtsnmgggzy.setTitle(title);
                        hhhtsnmgggzy.setTime(time);
                        hhhtsnmgggzy.setUrl(href1);
                        hhhtsnmgggzy.setChannle(channle);
                        xamnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }


    public void saveContent(String url){
        QueryWrapper<Xamnmgggzy> queryWrapper = new QueryWrapper<Xamnmgggzy>();
        queryWrapper.eq("url", url);

        List<Xamnmgggzy> list = xamnmgggzyService.list(queryWrapper);
        for (Xamnmgggzy hhhtsnmgggzy : list) {
            zyxxCont(hhhtsnmgggzy);
        }
    }

    public void zyxxCont(Xamnmgggzy hhhtsnmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(hhhtsnmgggzy.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {
                    String baseUrl = jsoupUtils.getBaseUrl(hhhtsnmgggzy.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    try {
                        document.getElementsByClass("ewb-article-sources").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    try {
                        document.getElementsByTag("h3").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    Elements detail_contect = document.getElementsByClass("ewb-article");
                    String HTML = detail_contect.html();
                    System.out.println("detail_contect.html()=="+detail_contect.html());
                    if(detail_contect.size() <= 0){
                        Elements detail_contectCC = document.getElementsByClass("article-area clearfix");
                        HTML = detail_contectCC.html();
                        System.out.println("detail_contectCC.html()=="+detail_contectCC.html());
                        if(detail_contectCC.size() <= 0){
                            Elements detail_contectCCCC = document.getElementsByClass("news-body mt20");
                            HTML = detail_contectCCCC.html();
                            System.out.println("detail_contectCCCC.html()=="+detail_contectCCCC.html());
                            if(detail_contectCCCC.size() > 0){
                                Elements detail_contectmt20 = document.getElementsByClass("mt20");
                                HTML += detail_contectmt20.html();
                                System.out.println("detail_contectCCCC.html()=="+detail_contectCCCC.html());
                            }
                        }
                    }




                    System.out.println("=======================");
                    System.out.println(HTML);
                    FileStrList fileStrList = jsoupUtilsView.rexStringHtmlXAM(HTML);
                    String html = fileStrList.getHtml();
                    hhhtsnmgggzy.setContent(html);
                    System.out.println("=======================");
                    System.out.println(html);
                    fileStrList.setHtml(html);
                    List<String> fileList = fileStrList.getFileList();
                    String fileIds = "";
                    for (String s : fileList) {
                        fileIds += s +",";
                    }
                    if(fileIds != "" && fileIds != null){
                        hhhtsnmgggzy.setFileIds(fileIds);
                    }
                    List<String> imgList = fileStrList.getImgList();
                    String imgIds = "";
                    for (String s : imgList) {
                        imgIds += s +",";
                    }
                    if(imgIds != "" && imgIds != null){
                        hhhtsnmgggzy.setImageIds(imgIds);
                    }
                    System.out.println("+++++++++++++++++++++++++++++++++++");
                    System.out.println(fileStrList.getHtml());
                    xamnmgggzyService.updateById(hhhtsnmgggzy);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }

    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }



}
