package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.ByzeMallbox;
import com.example.nmgggzyspyder.entity.HlbesMallbox;
import com.example.nmgggzyspyder.service.ByzeMallboxService;
import com.example.nmgggzyspyder.service.HlbesMallboxService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class MallBoxByzeCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private ByzeMallboxService byzeMallboxService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(2700);
            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[2]/div[1]/div[2]/div/div/input"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[2]/div[1]/div[2]/div/div/button"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 1; i <= 20; i++) {
                    try {
                        // /html/body/div[2]/div[2]/div[2]/ul/li[11]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[2]/div[1]/table/tbody/tr["+i+"]/td[2]"));
                        String title = elementTitle.getText();
                        WebElement elementA = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[2]/div[1]/table/tbody/tr["+i+"]/td[5]/a"));
                        String href1 =  elementA.getAttribute("href");
                        System.out.println(href1);
                        System.out.println(title);
                        String timeStr = "";
                        try {
                            WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[2]/div[1]/table/tbody/tr["+i+"]/td[3]"));
                            String time = elementTime.getText();
                            String substring = time.substring(3, time.length());
                            String substring5 = substring.substring(0,5);
                            String substring6 = substring.substring(9,substring.length());
                            System.out.println(substring5+substring6);
                            timeStr = substring5+substring6;
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                        System.out.println(href1);
                        System.out.println(title);
                        String idStr = title + href1  + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        ByzeMallbox byzeMallbox = new ByzeMallbox();
                        byzeMallbox.setId(md5id);
                        byzeMallbox.setTitle(title);
                        byzeMallbox.setUrl(href1);
                        byzeMallbox.setPetitionerTime(timeStr);
                        byzeMallbox.setReplyTime(timeStr);
                        byzeMallbox.setChannle(channle);
                        byzeMallboxService.saveOrUpdate(byzeMallbox);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }

    public void saveContent(String url){
        QueryWrapper<ByzeMallbox> queryWrapper = new QueryWrapper<ByzeMallbox>();
        queryWrapper.eq("url", url);
        List<ByzeMallbox> list = byzeMallboxService.list(queryWrapper);
        for (ByzeMallbox byzeMallbox : list) {
            zyxxCont(byzeMallbox);
        }
    }

    public void zyxxCont(ByzeMallbox byzeMallbox){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(byzeMallbox.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {
                    Thread.sleep(2700);
                    String baseUrl = jsoupUtils.getBaseUrl(byzeMallbox.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    //dataBean.qur_date
                    try {
                        Element detail_qur_date = document.getElementById("dataBean.questioncontent");
                        byzeMallbox.setPetitionerContent(detail_qur_date.text());
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    try {
                        Element questioncontent = document.getElementById("dataBean.answer");
                        byzeMallbox.setReplyContent(questioncontent.text());
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    byzeMallboxService.updateById(byzeMallbox);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }


    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }
    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

}
