package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.HhhtgggzyMallbox;
import com.example.nmgggzyspyder.entity.Hhhtsnmgggzy;
import com.example.nmgggzyspyder.service.HhhtgggzyMallboxService;
import com.example.nmgggzyspyder.service.HhhtsnmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class MallBoxCmsHHHTCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private HhhtsnmgggzyService hhhtsnmgggzyService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private HhhtgggzyMallboxService hhhtgggzyMallboxService;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.className("zxfinput"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.className("zxfokbtn"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                    Thread.sleep(2700);
                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 1; i <= 15; i++) {
                    try {
                        //   /html/body/div[2]/div[2]/div[2]/div/ul/li[1]/a
                        //                                                     /html/body/div[2]/div[2]/div[2]/div/ul/li[2]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/ul/li["+i+"]/a"));

                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/ul/li["+i+"]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);

                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/ul/li["+i+"]/span[1]"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());

                        HhhtgggzyMallbox hhhtsnmgggzy = new HhhtgggzyMallbox();
                        hhhtsnmgggzy.setId(md5id);
                        hhhtsnmgggzy.setTitle(title);
                        hhhtsnmgggzy.setReplyTime(time);
                        hhhtsnmgggzy.setUrl(href1);
                        hhhtsnmgggzy.setChannle(channle);
                        hhhtgggzyMallboxService.saveOrUpdate(hhhtsnmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }

    public void saveContent(String url){
        QueryWrapper<HhhtgggzyMallbox> queryWrapper = new QueryWrapper<HhhtgggzyMallbox>();
        queryWrapper.eq("url", url);
        List<HhhtgggzyMallbox> list = hhhtgggzyMallboxService.list(queryWrapper);
        for (HhhtgggzyMallbox hhhtsnmgggzy : list) {
            zyxxCont(hhhtsnmgggzy);
        }
    }

    public void zyxxCont(HhhtgggzyMallbox hhhtsnmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(hhhtsnmgggzy.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                WebElement petitionerName = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/div/div[1]/table/tbody/tr[1]/td[1]"));
                WebElement petitionerTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/div/div[1]/table/tbody/tr[1]/td[2]"));
                WebElement petitionerContent = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/div/div[1]/table/tbody/tr[3]/td"));
                WebElement replyUnit = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/div/div[2]/table/tbody/tr[1]/td[1]"));
                WebElement replyTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/div/div[2]/table/tbody/tr[1]/td[2]"));
                WebElement replyContent = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div/div/div[2]/table/tbody/tr[2]/td"));
                hhhtsnmgggzy.setPetitionerName(petitionerName.getText());
                hhhtsnmgggzy.setPetitionerTime(petitionerTime.getText());
                hhhtsnmgggzy.setPetitionerContent(petitionerContent.getText());
                hhhtsnmgggzy.setReplyUnit(replyUnit.getText());
                hhhtsnmgggzy.setReplyTime(replyTime.getText());
                hhhtsnmgggzy.setReplyContent(replyContent.getText());
                hhhtgggzyMallboxService.updateById(hhhtsnmgggzy);
            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }

    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
}
