package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.Nmgggzy;
import com.example.nmgggzyspyder.entity.NmgggzyMallbox;
import com.example.nmgggzyspyder.service.NmgggzyMallboxService;
import com.example.nmgggzyspyder.service.NmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class MallBoxCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private NmgggzyMallboxService nmgggzyMallboxService;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){

        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                if(j != 1){
                    try {
                        WebElement su = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[5]/div/a[last()]"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(1700);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
                for (int i = 2; i <= 16; i++) {
                    try {
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[4]/table/tbody/tr["+i+"]/td[2]/a"));
                        String title = elementTitle.getText();
                        System.out.println(title);
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div/div[4]/table/tbody/tr["+i+"]/td[3]"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        NmgggzyMallbox nmgggzyMallbox = new NmgggzyMallbox();
                        nmgggzyMallbox.setId(md5id);
                        nmgggzyMallbox.setTitle(title);
                        nmgggzyMallbox.setPetitionerTime(time);
                        nmgggzyMallbox.setUrl(href1);
                        nmgggzyMallbox.setChannle(channle);
                        nmgggzyMallboxService.saveOrUpdate(nmgggzyMallbox);
                        try {
                            saveContent(href1);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }

    public void saveContent(String url){
        QueryWrapper<NmgggzyMallbox> queryWrapper = new QueryWrapper<NmgggzyMallbox>();
        queryWrapper.eq("url", url);
        List<NmgggzyMallbox> list = nmgggzyMallboxService.list(queryWrapper);
        for (NmgggzyMallbox nmgggzyMallbox : list) {
            zyxxCont(nmgggzyMallbox);
        }
    }

    public void zyxxCont(NmgggzyMallbox nmgggzyMallbox){
        try {
            Document parse = Jsoup.parse(new URL(nmgggzyMallbox.getUrl()),60000);//设置60s超时
            String baseUrl = jsoupUtils.getBaseUrl(nmgggzyMallbox.getUrl());
            Document document = jsoupUtils.setUrl(parse, baseUrl);
            Elements elementsBySubtitle = document.getElementsByClass("ask-area");
            try {
                String html = elementsBySubtitle.toString();
                Document parse1 = Jsoup.parse(html);
                Elements title = parse1.getElementsByClass("title");
                Elements subtitle = parse1.getElementsByClass("subtitle");
                nmgggzyMallbox.setPetitionerContent(subtitle.toString());
            }catch (Exception e){
                e.printStackTrace();
            }
            Elements elementsByQuestionAreaSubtitle = document.getElementsByClass("question-area");
            try {
                String html = elementsByQuestionAreaSubtitle.toString();
                Document parse1 = Jsoup.parse(html);
                Elements elementsByClass = parse1.getElementsByClass("title");
                nmgggzyMallbox.setReplyContent(elementsByClass.toString());
            }catch (Exception e){
                e.printStackTrace();
            }

            nmgggzyMallboxService.updateById(nmgggzyMallbox);
        }catch (Exception e){
            e.printStackTrace();
        }
    }



    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
}
