package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.HlbesMallbox;
import com.example.nmgggzyspyder.entity.XamMallbox;
import com.example.nmgggzyspyder.service.HlbesMallboxService;
import com.example.nmgggzyspyder.service.XamMallboxService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class MallBoxXAMCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private XamMallboxService xamMallboxService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(2700);
            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    if(j != 1){
                        WebElement su = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div[4]/div/ul/li[2]/a"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                    }

                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 1; i <= 20; i++) {
                    try {
                        // /html/body/div[2]/div[2]/div[2]/div[4]/table/tbody/tr[1]/td[4]/a
                        // /html/body/div[2]/div[2]/div[2]/div[4]/table/tbody/tr[2]/td[4]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div[4]/table/tbody/tr["+i+"]/td[4]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div[4]/table/tbody/tr["+i+"]/td[1]"));
                        String title = elementTimeTitle.getText();
                        WebElement elementTimeTitleCont = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div[4]/table/tbody/tr["+i+"]/td[2]"));
                        String titleCont = elementTimeTitleCont.getText();

                        WebElement elementTimeTitleTime = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/div[4]/table/tbody/tr["+i+"]/td[3]"));
                        String titleTime = elementTimeTitleTime.getText();
                        System.out.println(title);
                        String idStr = title + href1  + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        XamMallbox hhhtsnmgggzy = new XamMallbox();
                        hhhtsnmgggzy.setId(md5id);
                        hhhtsnmgggzy.setTitle(title);
                        hhhtsnmgggzy.setUrl(href1);
                        hhhtsnmgggzy.setChannle(channle);
                        hhhtsnmgggzy.setReplyTime(titleTime);
                        hhhtsnmgggzy.setReplyContent(titleCont);
                        xamMallboxService.saveOrUpdate(hhhtsnmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }




    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }




}
