package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.HhhtgggzyMallbox;
import com.example.nmgggzyspyder.entity.Hlbenmgggzy;
import com.example.nmgggzyspyder.entity.HlbesMallbox;
import com.example.nmgggzyspyder.service.HlbenmgggzyService;
import com.example.nmgggzyspyder.service.HlbesMallboxService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class MallBoxhlbeggzyjyCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private HlbesMallboxService hlbesMallboxService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(2700);
            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.id("data-page-txt"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.cssSelector("#pager > div.m-pagination-jump > div > button"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 1; i <= 20; i++) {
                    try {
                        // /html/body/div[2]/div[2]/div[2]/ul/li[11]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/ul/li["+i+"]/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div[2]/div[2]/ul/li["+i+"]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        String idStr = title + href1  + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        HlbesMallbox hhhtsnmgggzy = new HlbesMallbox();
                        hhhtsnmgggzy.setId(md5id);
                        hhhtsnmgggzy.setTitle(title);
                        hhhtsnmgggzy.setUrl(href1);
                        hhhtsnmgggzy.setChannle(channle);
                        hlbesMallboxService.saveOrUpdate(hhhtsnmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }

    public void saveContent(String url){
        QueryWrapper<HlbesMallbox> queryWrapper = new QueryWrapper<HlbesMallbox>();
        queryWrapper.eq("url", url);
        List<HlbesMallbox> list = hlbesMallboxService.list(queryWrapper);
        for (HlbesMallbox hlbesMallbox : list) {
            zyxxCont(hlbesMallbox);
        }
    }

    public void zyxxCont(HlbesMallbox hlbesMallbox){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(hlbesMallbox.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {
                    Thread.sleep(2700);
                    String baseUrl = jsoupUtils.getBaseUrl(hlbesMallbox.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    //dataBean.qur_date
                    try {
                        Element detail_qur_date = document.getElementById("dataBean.qur_date");
                        hlbesMallbox.setPetitionerTime(detail_qur_date.text());
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    try {
                        Element questioncontent = document.getElementById("dataBean.questioncontent");
                        hlbesMallbox.setPetitionerContent(questioncontent.text());
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                    try {
                        Element answer = document.getElementById("dataBean.answer");
                        hlbesMallbox.setReplyContent(answer.text());
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                    try {
                        try {
                            for (int k = 0; k < 10; k++) {
                                try {
                                    Thread.sleep(2700);
                                    //                                           /html/body/div[2]/div/div[3]/div[2]/div/div/div/div[1]/div/div[2]/div[4]/div[2]/div/table/tbody/tr[2]/td[3]/div/div/ul[2]/li
                                    WebElement kw = driver.findElement(By.xpath("/html/body/div[2]/div/div[3]/div[2]/div/div/div/div[1]/div/div[2]/div[4]/div[2]/div/table/tbody/tr[2]/td[3]/div/div/ul["+k+"]/li"));
                                    String style = kw.getAttribute("style");
                                    System.out.println(style);
                                    int i = style.indexOf("text-align");
                                    int ii = style.indexOf("right");
                                    int iii = style.indexOf("blue");
                                    if(i >= 0 && ii > 0 && iii > 0){
                                        WebElement kwa = driver.findElement(By.xpath("/html/body/div[2]/div/div[3]/div[2]/div/div/div/div[1]/div/div[2]/div[4]/div[2]/div/table/tbody/tr[2]/td[3]/div/div/ul["+k+"]/li/a"));
                                        kwa.click();
                                        new WebDriverWait(driver, Duration.ofSeconds(5));
                                        break;
                                    }

                                }catch (Exception e){
                                    e.printStackTrace();
                                }
                            }
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                        try {
                            Thread.sleep(2700);
                            driver.switchTo().frame(0);
                            String pageSource1 = driver.getPageSource();
                            Document parse1 = Jsoup.parse(pageSource1);
                            Elements elementsByClass = parse1.getElementsByClass("mini-grid-rows-content");
                            FileStrList fileStrList = jsoupUtilsView.rexStringHtmlHLBEMAXBOX(elementsByClass.html());
                            String fileListStr = "";
                            List<String> fileList = fileStrList.getFileList();
                            for (String s : fileList) {
                                fileListStr += s + ",";
                            }
                            List<String> imgList = fileStrList.getImgList();
                            for (String s : imgList) {
                                fileListStr += s + ",";
                            }
                            new WebDriverWait(driver, Duration.ofSeconds(5));
                            hlbesMallbox.setFilelist(fileListStr);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }catch (Exception e){
                        e.printStackTrace();
                    }



                    hlbesMallboxService.updateById(hlbesMallbox);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }

    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }




}
