package com.example.nmgggzyspyder.utils;

import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

@Component
public class JsoupUtilsView {

    public static String filePath = "D:/ruoyi/updatePathggzy/";
    public static String filePathHHHT = "D:/ruoyi/updatePathhhht/";
    public static String filePathBaotou = "D:/ruoyi/updatePathBaotou/";
    public static String filePathMZL = "D:/ruoyi/updatePathMZL/";
    public static String filePathEEDS = "D:/ruoyi/updatePathEEDS/";
    public static String filePathHLBE = "D:/ruoyi/updatePathHLBE/";
    public static String filePathXLGLM = "D:/ruoyi/updatePatXLGLM/";
    public static String filePathWHS = "D:/ruoyi/updatePatWHS/";
    public static String filePathHLBEMALLBOX = "D:/ruoyi/b/";
    public static String filePathCFS = "D:/ruoyi/updatePatCFS/";
    public static String filePathWLCB = "D:/ruoyi/updatePatWLCB/";
    public static String filePathTLS = "D:/ruoyi/updatePatTLS/";
    public static String filePathBynr = "D:/ruoyi/updatePatBynr/";
    public static String filePathALS = "D:/ruoyi/updatePatALS/";
    public static String filePathXAM = "D:/ruoyi/updatePatXAM/";

    /*
     * 下载a标签对应的文件
     * */
    public FileStrList rexStringHtml(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text1);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(text);
                }
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePath);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){

                    String fileTypeByUrl = getFileTypeByUrl(src);
                    if(!ObjectUtils.isEmpty(fileTypeByUrl)){
                        //下载图片
                        String ff = downLoadFromUrl(src,md5id+"."+fileTypeByUrl,JsoupUtilsView.filePath);
                        if(ff != "" && ff != null){
                            imgList.add(md5id+"."+fileTypeByUrl);
                            element.attr("src",md5id+"."+fileTypeByUrl);
                        }
                    }else{
                        //下载图片
                        String ff = downLoadFromUrl(src,md5id+"."+"png",JsoupUtilsView.filePath);
                        if(ff != "" && ff != null){
                            imgList.add(md5id+"."+"png");
                            element.attr("src",md5id+"."+"png");
                        }
                    }


                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePath+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    //下载图片
                    String fileTypeByUrl = getFileTypeByUrl(src);
                    if(!ObjectUtils.isEmpty(fileTypeByUrl)){
                        //下载图片
                        String ff = downLoadFromUrl(src,md5id+"."+fileTypeByUrl,JsoupUtilsView.filePath);
                        if(ff != "" && ff != null){
                            imgList.add(md5id+"."+fileTypeByUrl);
                            element.attr("src",md5id+"."+fileTypeByUrl);
                        }
                    }else{
                        //下载图片
                        String ff = downLoadFromUrl(src,md5id+"."+"png",JsoupUtilsView.filePath);
                        if(ff != "" && ff != null){
                            imgList.add(md5id+"."+"png");
                            element.attr("src",md5id+"."+"png");
                        }
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePath);
                if(ff != "" && ff != null){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }

    public FileStrList rexStringHtmlHHHT(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text);
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathHHHT);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathHHHT);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHHHT+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathHHHT);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathHHHT);
                if(ff != "" && ff != null){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }


    public FileStrList rexStringHtmlMZT(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text);
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathMZL);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathMZL);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathMZL+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathMZL);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathMZL);
                if(ff != "" && ff != null){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }


    public FileStrList rexStringHtmlWHS(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text1);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(text);
                }
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathWHS);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    if(ObjectUtils.isEmpty(fileType)){
                        fileType = getFileTypeByUrl(src);
                    }
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathWHS);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }else{
                        String ff = downLoadFromUrl(src,md5id+"."+"png",JsoupUtilsView.filePathWHS);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+"png");
                        }
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWHS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    if(ObjectUtils.isEmpty(fileType)){
                        fileType = getFileTypeByUrl(src);
                    }
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathWHS);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }else{
                        String ff = downLoadFromUrl(src,md5id+"."+"png",JsoupUtilsView.filePathWHS);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+"png");
                        }
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathWHS);
                if(ff != "" && ff != null){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }

    String baseUrlHLBE = "http://www.hlbeggzyjy.org.cn/TPFrame/infobase/pages/attachmanage/";

    public FileStrList rexStringHtmlHLBEMAXBOX(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = baseUrlHLBE + link.attr("href") ;
                String text1 = link.text();
                if(text1.equals("点击下载")){
                    continue;
                }
                String fileType = getFileType(text1);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(text);
                }
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathHLBEMALLBOX);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = baseUrlHLBE +  element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    if(ObjectUtils.isEmpty(fileType)){
                        fileType = getFileTypeByUrl(src);
                    }
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathHLBEMALLBOX);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }else{
                        String ff = downLoadFromUrl(src,md5id+"."+"png",JsoupUtilsView.filePathHLBEMALLBOX);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+"png");
                        }
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = baseUrlHLBE +  element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBEMALLBOX+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    if(ObjectUtils.isEmpty(fileType)){
                        fileType = getFileTypeByUrl(src);
                    }
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathHLBEMALLBOX);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }else{
                        String ff = downLoadFromUrl(src,md5id+"."+"png",JsoupUtilsView.filePathHLBEMALLBOX);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+"png");
                        }
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = baseUrlHLBE +  element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathHLBEMALLBOX);
                if(ff != "" && ff != null){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }



    public FileStrFuJianList rexStringHtmlWHSFUJIAN(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrFuJianList fileStrList = new FileStrFuJianList();
        List<StrNameType> fileList = new ArrayList<StrNameType>();
        List<StrNameType> imgList = new ArrayList<StrNameType>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text1);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(text);
                }
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathWHS);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    StrNameType strNameType = new StrNameType();
                    strNameType.setName(text1);
                    strNameType.setUrl(md5id+"."+fileType);
                    fileList.add(strNameType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String fileType = getFileType(src);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(src);
                }
                //下载图片
                String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathWHS);
                if(ff != "" && ff != null){
                    StrNameType strNameType = new StrNameType();
                    strNameType.setName(md5id+"."+fileType);
                    strNameType.setUrl(md5id+"."+fileType);
                    imgList.add(strNameType);
                    element.attr("src",md5id+"."+fileType);
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String fileType = getFileType(src);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(src);
                }
                //下载图片
                String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathWHS);
                if(ff != "" && ff != null){
                    StrNameType strNameType = new StrNameType();
                    strNameType.setName(md5id+"."+fileType);
                    strNameType.setUrl(md5id+"."+fileType);
                    imgList.add(strNameType);
                    element.attr("src",md5id+"."+fileType);
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String pm4Type = getFileTypeByUrl(src);
                if(pm4Type == null || pm4Type == ""){
                    pm4Type = "mp4";
                }
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePath);
                if(ff != "" && ff != null){
                    StrNameType strNameType = new StrNameType();
                    strNameType.setName(md5id+"."+pm4Type);
                    strNameType.setUrl(md5id+"."+pm4Type);
                    imgList.add(strNameType);
                    element.attr("src",md5id+"."+pm4Type);
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }

    public FileStrList rexStringHtmlCFS(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text1);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(text);
                }
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathCFS);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathCFS);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathCFS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathCFS);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathCFS);
                if(ff != "" && ff != null){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }

    public FileStrList rexStringHtmlWLCB(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text1);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(text);
                }
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                if(fileType != null && fileType != "" && fileType != "null"){
                    String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathWLCB);
                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                        fileList.add(md5id+"."+fileType);
                        link.attr("href",md5id+"."+fileType);
                    }
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathWLCB);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathWLCB+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathWLCB);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathCFS);
                if(ff != "" && ff != null ){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }

    public FileStrList rexStringHtmlTLS(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text1);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(text);
                }
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                if(fileType != null && fileType != "" && fileType != "null"){
                    String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathTLS);
                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                        fileList.add(md5id+"."+fileType);
                        link.attr("href",md5id+"."+fileType);
                    }
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathTLS);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathTLS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathTLS);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathTLS);
                if(ff != "" && ff != null ){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }


    public FileStrList rexStringHtmlByne(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text1);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(text);
                }
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                if(fileType != null && fileType != "" && fileType != "null"){
                    String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathBynr);
                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                        fileList.add(md5id+"."+fileType);
                        link.attr("href",md5id+"."+fileType);
                    }
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathBynr);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBynr+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathBynr);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathBynr);
                if(ff != "" && ff != null ){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }

    String alsBaseUrl = "http://www.alsggzyjy.cn/doFile/download/?attachmentId=";

    public FileStrList rexStringHtmlALS(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            try {
                Elements hasHoverList = doc.getElementsByClass("hasHover");
                for (Element byClass : hasHoverList) {
                    System.out.println(byClass);
                    String onclick1 = byClass.attr("onclick");
                    Elements onclick = byClass.getElementsByAttribute("onclick");
                    String html1 = onclick.html();
                    System.out.println(html1);
                    onclick1 = onclick1.replace("downloadFun('", "");
                    onclick1 = onclick1.replace("')", "");
                    String dowUrl = alsBaseUrl + onclick1;
                    System.out.println(onclick1);
                    if(!ObjectUtils.isEmpty(onclick1)){
                        String ff = downLoadFromUrl(dowUrl,onclick1+html1,JsoupUtilsView.filePathALS);
                        if(ff != "" && ff != null){
                            onclick.removeAttr("onclick");
                            onclick.removeAttr("style");
                            onclick.clear();
                            byClass.text("");
                            byClass.append("<a  target=\"_blank\" href=\""+onclick1+html1+"\" class=\"file-file\" >"+html1+"</a>");
                            fileList.add(onclick1+html1);
                        }
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text1);
                if(fileType == "" || fileType == null || fileType == "null"){
                    fileType = getFileTypeByUrl(text);
                }
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                if(fileType != null && fileType != "" && fileType != "null"){
                    String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathALS);
                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                        fileList.add(md5id+"."+fileType);
                        link.attr("href",md5id+"."+fileType);
                    }
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    if(ObjectUtils.isEmpty(fileType)){
                        fileType = getFileTypeByUrl(src);
                    }
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathALS);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathALS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    if(ObjectUtils.isEmpty(fileType)){
                        fileType = getFileTypeByUrl(src);
                    }
                    //下载图片
                    if(fileType != null && fileType != "" && fileType != "null"){
                        String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathALS);
                        if(ff != "" && ff != null && fileType != "" && fileType != null){
                            imgList.add(md5id+"."+fileType);
                            element.attr("src",md5id+"."+fileType);
                        }
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathALS);
                if(ff != "" && ff != null ){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }

    public FileStrList rexStringHtmlXLGLM(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                System.out.println(text);
                String text1 = link.text();
                System.out.println(text1);
                String fileType = getFileType(text);
                System.out.println(fileType);
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathXLGLM);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathXLGLM);
                    if(ff != "" && ff != null && fileType != "" && fileType != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXLGLM+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathXLGLM);
                    if(ff != "" && ff != null && fileType != "" && fileType != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathXLGLM);
                if(ff != "" && ff != null ){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }

    String baseBaotou = "https://www.btggzyjy.cn/";

    public FileStrList rexStringHtmlBaotou(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                if(text.equals("javascript:void(0);")){
                    //https://www.btggzyjy.cn/btggzynew/03041b8d-4584-49d4-8a64-2dd18813afa5/1b3698c5-71fd-4586-ab92-34747fc39a13/%E6%8A%95%E6%A0%87%E4%BA%BA%E5%85%8D%E7%BC%B4%E6%8A%95%E6%A0%87%E4%BF%9D%E8%AF%81%E9%87%91%E4%BF%A1%E7%94%A8%E6%89%BF%E8%AF%BA%E5%87%BD.docx
                    String onclick = link.attr("onclick");
                    onclick = onclick.replace("ztbfjyz('","");
                    onclick = onclick.replace("','0','1')","");
                    onclick = onclick.replace("','0','1')","");
                    int i = onclick.indexOf(baseBaotou);
                    if(i < 0){
                        onclick = baseBaotou+onclick;
                    }
                    String fileType = getFileType(onclick);
                    String md5id = DigestUtils.md5DigestAsHex(onclick.getBytes());
                    String ff = downLoadFromUrl(onclick,md5id+"."+fileType,JsoupUtilsView.filePathBaotou);
                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                        fileList.add(md5id+"."+fileType);
                        link.attr("href",md5id+"."+fileType);
                        link.removeAttr("onclick");
                    }
                }else{
                    String text1 = link.text();
                    String fileType = getFileType(text);
                    //下载文件
                    int i = text1.indexOf(".docx");
                    if(i >= 0){
                        fileType = "docx";
                    }
                    if(fileType != null){
                        continue;
                    }
                    if(fileType != "null"){
                        continue;
                    }
                    if(fileType != ""){
                        continue;
                    }
                    String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                    String dowurl = text;
                    int ii = dowurl.indexOf(baseBaotou);
                    if(ii < 0){
                        dowurl = baseBaotou+dowurl;
                    }
                    String ff = downLoadFromUrl(dowurl,md5id+"."+fileType,JsoupUtilsView.filePathBaotou);
                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                        fileList.add(md5id+"."+fileType);
                        link.attr("href",md5id+"."+fileType);
                    }
                }

            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String dowurl = src;
                    int ii = dowurl.indexOf(baseBaotou);
                    if(ii < 0){
                        dowurl = baseBaotou+dowurl;
                    }
                    String ff = downLoadFromUrl(dowurl,md5id+"."+fileType,JsoupUtilsView.filePathBaotou);
                    if(ff != "" && ff != null && fileType != "" && fileType != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathBaotou+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathBaotou);
                    if(ff != "" && ff != null && fileType != "" && fileType != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String fileType = getFileType(src);
                if(ObjectUtils.isEmpty(fileType)){
                    fileType += "mp4";
                }
                //下载图片
                String dowurl = src;
                int ii = dowurl.indexOf(baseBaotou);
                if(ii < 0){
                    dowurl = baseBaotou+dowurl;
                }
                String ff =  downLoadFromUrl(dowurl,md5id+"."+fileType,JsoupUtilsView.filePathBaotou);
                if(ff != "" && ff != null){
                    fileList.add(md5id+"."+fileType);
                    element.attr("src",md5id+"."+fileType);
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }

    public FileStrList rexStringHtmlEEDS(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text);
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathEEDS);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathEEDS);
                    if(ff != "" && ff != null && fileType != "" && fileType != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathEEDS+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathEEDS);
                    if(ff != "" && ff != null && fileType != "" && fileType != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathEEDS);
                if(ff != "" && ff != null){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }


    public FileStrList rexStringHtmlHLBE(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text);
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathHLBE);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathHLBE);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathHLBE+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathHLBE);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathHLBE);
                if(ff != "" && ff != null){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }
    public FileStrList rexStringHtmlXAM(String html) throws Exception {
        Document doc = Jsoup.parse(html);
        FileStrList fileStrList = new FileStrList();
        List<String> fileList = new ArrayList<String>();
        List<String> imgList = new ArrayList<String>();
        try {
            Elements links = doc.select("a[href]");
            for (Element link : links) {
                String text = link.attr("href");
                String text1 = link.text();
                String fileType = getFileType(text);
                //下载文件
                int i = text1.indexOf(".docx");
                if(i >= 0){
                    fileType = "docx";
                }
                if(fileType == null){
                    continue;
                }
                if(fileType == "null"){
                    continue;
                }
                if(fileType == ""){
                    continue;
                }
                String md5id = DigestUtils.md5DigestAsHex(text.getBytes());
                String ff = downLoadFromUrl(text,md5id+"."+fileType,JsoupUtilsView.filePathXAM);
                if(ff != "" && ff != null && fileType != null && fileType != ""){
                    fileList.add(md5id+"."+fileType);
                    link.attr("href",md5id+"."+fileType);
                }
            }
            Elements linksrc = doc.select("img[src]");
            for (Element element : linksrc) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathXAM);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkimg = doc.select("IMG[src]");
            for (Element element : linkimg) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                int ipng = src.indexOf("data:image/png;base64,");
                if(ipng >= 0){
                    src = src.replace("data:image/png;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ipng2 = src.indexOf("data:image/PNG;base64,");
                if(ipng2 >= 0){
                    src = src.replace("data:image/PNG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".png");
                    imgList.add(md5id+".png");
                    element.attr("src",md5id+".png");
                }
                int ijpg = src.indexOf("data:image/jpg;base64,");
                if(ijpg >= 0){
                    src = src.replace("data:image/jpg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int ijpg2 = src.indexOf("data:image/JPG;base64,");
                if(ijpg2 >= 0){
                    src = src.replace("data:image/JPG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".jpg");
                    imgList.add(md5id+".jpg");
                    element.attr("src",md5id+".jpg");
                }
                int jpeg = src.indexOf("data:image/jpeg;base64,");
                if(jpeg >= 0){
                    src = src.replace("data:image/jpeg;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int jpeg2 = src.indexOf("data:image/JPEG;base64,");
                if(jpeg2 >= 0){
                    src = src.replace("data:image/JPEG;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".jpeg");
                    imgList.add(md5id+".jpeg");
                    element.attr("src",md5id+".jpeg");
                }
                int gif = src.indexOf("data:image/gif;base64,");
                if(gif >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                int gif2 = src.indexOf("data:image/gif;base64,");
                if(gif2 >= 0){
                    src = src.replace("data:image/gif;base64,", "");
                    ImageUtil.convertBase64StrToImage(src,JsoupUtilsView.filePathXAM+"/"+md5id+".gif");
                    imgList.add(md5id+".gif");
                    element.attr("src",md5id+".gif");
                }
                if(ipng < 0 && ipng2 < 0 && ijpg < 0 && ijpg2 < 0 && jpeg < 0 && jpeg2 < 0 && gif < 0 && gif2 < 0){
                    String fileType = getFileType(src);
                    //下载图片
                    String ff = downLoadFromUrl(src,md5id+"."+fileType,JsoupUtilsView.filePathXAM);
                    if(ff != "" && ff != null){
                        imgList.add(md5id+"."+fileType);
                        element.attr("src",md5id+"."+fileType);
                    }
                }
            }
            Elements linkvideo = doc.select("video[src]");
            for (Element element : linkvideo) {
                String src = element.attr("src");
                String md5id = DigestUtils.md5DigestAsHex(src.getBytes());
                String ff =  downLoadFromUrl(src,md5id,JsoupUtilsView.filePathXAM);
                if(ff != "" && ff != null){
                    fileList.add(md5id+".mp4");
                    element.attr("src",md5id+".mp4");
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println(doc.html());
        fileStrList.setFileList(fileList);
        fileStrList.setImgList(imgList);
        fileStrList.setHtml(doc.html());
        return fileStrList;
    }



    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    /**
     * 从网络Url中下载文件
     *
     * @param urlStr
     * @param fileName
     * @param savePath
     * @throws IOException
     */
    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                e.printStackTrace();
                return null;
            }
        }
        return null;
    }

}
