package com.example.nmgggzyspyder.spyder;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.Alsnmgggzy;
import com.example.nmgggzyspyder.entity.Btsnmgggzy;
import com.example.nmgggzyspyder.entity.Bynrnmgggzy;
import com.example.nmgggzyspyder.service.AlsnmgggzyService;
import com.example.nmgggzyspyder.service.BynrnmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.HttpResponse;
import kong.unirest.JsonNode;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.ArrayList;
import java.util.List;

@Component
public class CmsALSCawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private AlsnmgggzyService alsnmgggzyService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,String areaCode,int page,int rows,String colType,String subColType,String channle,int pageNum){
        for(int i = page; i <= pageNum; i++){
            System.out.println(url);
            HttpResponse<JsonNode> response = null;
            if(ObjectUtils.isEmpty(subColType)){
                response = Unirest.post(url)
                        .header("accept", "application/json")
                        .queryString("areaCode", areaCode)
                        .queryString("page", page)
                        .queryString("rows", rows)
                        .queryString("colType", colType)
                        .asJson();
            }
            if(!ObjectUtils.isEmpty(subColType)){
                response  = Unirest.post(url)
                        .header("accept", "application/json")
                        .queryString("areaCode", areaCode)
                        .queryString("page", page)
                        .queryString("rows", rows)
                        .queryString("colType", colType)
                        .queryString("subColType", subColType)
                        .asJson();
            }

            JsonNode body = response.getBody();
            System.out.println(body);
            String sStr = body.toString();
            JSONObject jsonObj = JSON.parseObject(sStr);
            Object listData = jsonObj.get("data");

            JSONObject jsonObjData = JSON.parseObject(listData.toString());

            Object listDataTime = jsonObjData.get("list");
            JSONArray arraycoDataTime = JSON.parseArray(String.valueOf(listDataTime));
            for (Object o : arraycoDataTime) {

                JSONObject jsonObjDataJSON = JSON.parseObject(o.toString());
                Object id = jsonObjDataJSON.get("id");
                Object lastUpdateTime = jsonObjDataJSON.get("lastUpdateTime");
                Object publishTime = jsonObjDataJSON.get("publishTime");
                Object title = jsonObjDataJSON.get("title");
                Object updateUserName = jsonObjDataJSON.get("updateUserName");

                try {
                    Object attachmentFileName = jsonObjDataJSON.get("attachmentFileName");
                    Object attachmentType = jsonObjDataJSON.get("attachmentType");
                    Object attachmentId = jsonObjDataJSON.get("attachmentId");
                    if(!ObjectUtils.isEmpty(attachmentType) && !ObjectUtils.isEmpty(attachmentId)){
                        String href1 = "http://www.alsggzyjy.cn/doFile/download/?attachmentId="+attachmentId;
                        String ff = downLoadFromUrl(href1,attachmentFileName.toString(),JsoupUtilsView.filePathALS);
                        if(ff != "" && ff != null ){
                            Alsnmgggzy hhhtsnmgggzy = new Alsnmgggzy();
                            hhhtsnmgggzy.setId(id.toString());
                            hhhtsnmgggzy.setTitle(attachmentFileName.toString());
                            hhhtsnmgggzy.setTime(publishTime.toString());
                            hhhtsnmgggzy.setUrl(ff);
                            hhhtsnmgggzy.setChannle(channle);
                            hhhtsnmgggzy.setContent("文件文章");
                            alsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                            continue;
                        }
                    }
                }catch (Exception e){
                    e.printStackTrace();
                }

                System.out.println(id);
                System.out.println(lastUpdateTime);
                System.out.println(publishTime);
                System.out.println(title);
                System.out.println(updateUserName);
                String urlPage = "http://www.alsggzyjy.cn/PublicServer/public/backstageManagement/showDetail.html?colType=organizationConstruction&id="+id;
                Alsnmgggzy alsnmgggzy = new Alsnmgggzy();
                alsnmgggzy.setId(id.toString());
                alsnmgggzy.setTitle(title.toString());
                alsnmgggzy.setUrl(urlPage);
                alsnmgggzy.setTime(publishTime.toString());
                alsnmgggzy.setChannle(channle);
                alsnmgggzyService.saveOrUpdate(alsnmgggzy);
                try {
                    saveContent(urlPage);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }
        }
    }

    public void saveContent(String url){
        QueryWrapper<Alsnmgggzy> queryWrapper = new QueryWrapper<Alsnmgggzy>();
        queryWrapper.eq("url", url);
        List<Alsnmgggzy> list = alsnmgggzyService.list(queryWrapper);
        for (Alsnmgggzy hhhtsnmgggzy : list) {
            zyxxCont(hhhtsnmgggzy);
        }
    }

    public void zyxxCont(Alsnmgggzy hhhtsnmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(hhhtsnmgggzy.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {
                    String baseUrl = jsoupUtils.getBaseUrl(hhhtsnmgggzy.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    System.out.println(parse.html());
                    Element elementsByClass = document.getElementById("body_div");
                    System.out.println(elementsByClass.html());
                    try {
                        document.getElementsByClass("crumbsDiv").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    try {
                        document.getElementsByClass("showDiv_title").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    String HTML = elementsByClass.html();
                    System.out.println("=======================");
                    System.out.println(HTML);
                    FileStrList fileStrList = jsoupUtilsView.rexStringHtmlALS(HTML);
                    String html = fileStrList.getHtml();
                    hhhtsnmgggzy.setContent(html);
                    System.out.println("=======================");
                    System.out.println(html);
                    fileStrList.setHtml(html);
                    List<String> fileList = fileStrList.getFileList();
                    String fileIds = "";
                    for (String s : fileList) {
                        fileIds += s +",";
                    }
                    if(fileIds != "" && fileIds != null){
                        hhhtsnmgggzy.setFileIds(fileIds);
                    }
                    List<String> imgList = fileStrList.getImgList();
                    String imgIds = "";
                    for (String s : imgList) {
                        imgIds += s +",";
                    }
                    if(imgIds != "" && imgIds != null){
                        hhhtsnmgggzy.setImageIds(imgIds);
                    }
                    System.out.println("+++++++++++++++++++++++++++++++++++");
                    System.out.println(fileStrList.getHtml());
                    alsnmgggzyService.updateById(hhhtsnmgggzy);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
}
