package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.Btsnmgggzy;
import com.example.nmgggzyspyder.entity.Hhhtsnmgggzy;
import com.example.nmgggzyspyder.service.BtsnmgggzyService;
import com.example.nmgggzyspyder.service.HhhtsnmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class CmsBaoTouShiCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private BtsnmgggzyService btsnmgggzyService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            //Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.id("data-page-txt"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.cssSelector("#pagin-box > div > div > div.m-pagination-jump > div > button"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                    //Thread.sleep(2700);
                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 1; i <= 10; i++) {
                    try {
                        WebElement elementTitle = driver.findElement(By.xpath("//*[@id=\"list\"]/li["+i+"]/p/a"));
                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);
                        String title = elementTitle.getText();
                        System.out.println(title);
                        WebElement elementTime = driver.findElement(By.xpath("//*[@id=\"list\"]/li["+i+"]/span"));
                        String time = elementTime.getText();
                        System.out.println(time);
                        try {
                            if(!ObjectUtils.isEmpty(href1)){
                                int i1 = href1.indexOf("https://www.btggzyjy.cn/");
                                if(i1 < 0){
                                    String md5id = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    Btsnmgggzy hhhtsnmgggzy = new Btsnmgggzy();
                                    hhhtsnmgggzy.setId(md5id);
                                    hhhtsnmgggzy.setTitle(title);
                                    hhhtsnmgggzy.setTime(time);
                                    hhhtsnmgggzy.setUrl(href1);
                                    hhhtsnmgggzy.setChannle(channle);
                                    hhhtsnmgggzy.setContent("链接文章");
                                    btsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                    continue;
                                }
                            }
                            if(!ObjectUtils.isEmpty(href1)){
                                String fileType = getFileType(href1);
                                if(fileType == "" || fileType == null || fileType == "null"){
                                    fileType = getFileTypeByUrl(href1);
                                }
                                if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                    if(!ObjectUtils.isEmpty(title)){
                                        String md5id = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                        String ff = downLoadFromUrl(href1,title+md5id+"."+fileType,JsoupUtilsView.filePathBaotou);
                                        if(ff != "" && ff != null && fileType != null && fileType != ""){
                                            Btsnmgggzy hhhtsnmgggzy = new Btsnmgggzy();
                                            hhhtsnmgggzy.setId(md5id);
                                            hhhtsnmgggzy.setTitle(title);
                                            hhhtsnmgggzy.setTime(time);
                                            hhhtsnmgggzy.setUrl(title+md5id+"."+fileType);
                                            hhhtsnmgggzy.setChannle(channle);
                                            hhhtsnmgggzy.setContent("文件文章");
                                            btsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                            continue;
                                        }
                                    }
                                }
                            }
                        }catch (Exception eee){
                            eee.printStackTrace();
                        }
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        Btsnmgggzy hhhtsnmgggzy = new Btsnmgggzy();
                        hhhtsnmgggzy.setId(md5id);
                        hhhtsnmgggzy.setTitle(title);
                        hhhtsnmgggzy.setTime(time);
                        hhhtsnmgggzy.setUrl(href1);
                        hhhtsnmgggzy.setChannle(channle);
                        btsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }

    public void saveContent(String url){
        QueryWrapper<Btsnmgggzy> queryWrapper = new QueryWrapper<Btsnmgggzy>();
        queryWrapper.eq("url", url);
        List<Btsnmgggzy> list = btsnmgggzyService.list(queryWrapper);
        for (Btsnmgggzy btsnmgggzy : list) {
            zyxxCont(btsnmgggzy);
        }
    }

    public void zyxxCont(Btsnmgggzy btsnmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(btsnmgggzy.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                //Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {
                    String baseUrl = jsoupUtils.getBaseUrl(btsnmgggzy.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    Elements detail_contect = document.getElementsByClass("news-item");
                    String HTML = detail_contect.html();
                    System.out.println("detail_contect.html()=="+detail_contect.html());
                    if(detail_contect.size() <= 0){
                        Elements detail_contectCC = document.getElementsByClass("article-area clearfix");
                        HTML = detail_contectCC.html();
                        System.out.println("detail_contectCC.html()=="+detail_contectCC.html());
                        if(detail_contectCC.size() <= 0){
                            Elements detail_contectCCCC = document.getElementsByClass("news-body mt20");
                            HTML = detail_contectCCCC.html();
                            System.out.println("detail_contectCCCC.html()=="+detail_contectCCCC.html());
                            if(detail_contectCCCC.size() > 0){
                                Elements detail_contectmt20 = document.getElementsByClass("mt20");
                                HTML += detail_contectmt20.html();
                                System.out.println("detail_contectCCCC.html()=="+detail_contectCCCC.html());
                            }
                        }
                    }
                    System.out.println("=======================");
                    System.out.println(HTML);
                    FileStrList fileStrList = jsoupUtilsView.rexStringHtmlBaotou(HTML);
                    String html = fileStrList.getHtml();
                    btsnmgggzy.setContent(html);
                    System.out.println("=======================");
                    System.out.println(html);
                    fileStrList.setHtml(html);
                    List<String> fileList = fileStrList.getFileList();
                    String fileIds = "";
                    for (String s : fileList) {
                        fileIds += s +",";
                    }
                    if(fileIds != "" && fileIds != null){
                        btsnmgggzy.setFileIds(fileIds);
                    }
                    List<String> imgList = fileStrList.getImgList();
                    String imgIds = "";
                    for (String s : imgList) {
                        imgIds += s +",";
                    }
                    if(imgIds != "" && imgIds != null){
                        btsnmgggzy.setImageIds(imgIds);
                    }
                    System.out.println("+++++++++++++++++++++++++++++++++++");
                    System.out.println(fileStrList.getHtml());
                    btsnmgggzyService.updateById(btsnmgggzy);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }

    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

}
