package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.Cfsnmgggzy;
import com.example.nmgggzyspyder.entity.FileIds;
import com.example.nmgggzyspyder.entity.ImageIds;
import com.example.nmgggzyspyder.entity.Whsnmgggzy;
import com.example.nmgggzyspyder.service.CfsnmgggzyService;
import com.example.nmgggzyspyder.service.FileIdsService;
import com.example.nmgggzyspyder.service.ImageIdsService;
import com.example.nmgggzyspyder.service.WhsnmgggzyService;
import com.example.nmgggzyspyder.utils.*;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class CmsCFSCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private CfsnmgggzyService cfsnmgggzyService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle,String isClick[]){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);

            try {
                if(isClick.length > 0){
                    for (String s : isClick) {
                       try {
                           WebElement is = driver.findElement(By.xpath(s));
                           is.click();
                           new WebDriverWait(driver, Duration.ofSeconds(5));
                           Thread.sleep(1700);
                       }catch (Exception e){
                           e.printStackTrace();
                       }
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }

            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.id("GoToPagingNo"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.id("submit2"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                    Thread.sleep(2700);
                }catch (Exception e){
                    e.printStackTrace();
                }

                for (int i = 1; i <= 40; i++) {
                    try {
                        //   /html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr[1]/td[2]/a
                        //   /html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr[3]/td[2]/a
                        //   /html/body/div[1]/div/div[2]/div/div[2]/div[2]/div[2]/div/div[1]/ul/li[1]/a
                        //   /html/body/div[1]/div/div[2]/div/div[2]/div[2]/div[2]/div/div[1]/ul/li[3]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr["+i+"]/td[2]/a"));

                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr["+i+"]/td[2]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        //  /html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr[37]/td[3]
                        //  /html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr[33]/td[3]
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr["+i+"]/td[3]"));
                        String time = elementTime.getText();
                        try {
                            time = time.replace("[", "");
                            time = time.replace("]", "");
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("ggzy.chifeng.gov.cn");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Cfsnmgggzy hhhtsnmgggzy = new Cfsnmgggzy();
                                hhhtsnmgggzy.setId(md5idhref1);
                                hhhtsnmgggzy.setTitle(title);
                                hhhtsnmgggzy.setTime(time);
                                hhhtsnmgggzy.setUrl(href1);
                                hhhtsnmgggzy.setChannle(channle);
                                hhhtsnmgggzy.setContent("链接文章");
                                cfsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(fileType == "" || fileType == null || fileType == "null"){
                                fileType = getFileTypeByUrl(href1);
                            }
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idStr = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idStr+"."+fileType,JsoupUtilsView.filePathCFS);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Cfsnmgggzy hhhtsnmgggzy = new Cfsnmgggzy();
                                        hhhtsnmgggzy.setId(md5id);
                                        hhhtsnmgggzy.setTitle(title);
                                        hhhtsnmgggzy.setTime(time);
                                        hhhtsnmgggzy.setUrl(title+md5idStr+"."+fileType);
                                        hhhtsnmgggzy.setChannle(channle);
                                        hhhtsnmgggzy.setContent("文件文章");
                                        cfsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }

                        Cfsnmgggzy hhhtsnmgggzy = new Cfsnmgggzy();
                        hhhtsnmgggzy.setId(md5id);
                        hhhtsnmgggzy.setTitle(title);
                        hhhtsnmgggzy.setTime(time);
                        hhhtsnmgggzy.setUrl(href1);
                        hhhtsnmgggzy.setChannle(channle);
                        cfsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }
    public void zyxxPage(String url,int pageNum,String channle,String isClick[]){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);


            try {
                if(isClick.length > 0){
                    for (String s : isClick) {
                       try {
                           WebElement is = driver.findElement(By.xpath(s));
                           is.click();
                           new WebDriverWait(driver, Duration.ofSeconds(5));
                           Thread.sleep(1700);
                       }catch (Exception e){
                           e.printStackTrace();
                       }
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }

            for (int j = 1; j <= pageNum; j++) {
                driver.get(url+j);
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(1700);
                for (int i = 1; i <= 40; i++) {
                    try {
                        //   /html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr[1]/td[2]/a
                        //   /html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr[3]/td[2]/a
                        //   /html/body/div[1]/div/div[2]/div/div[2]/div[2]/div[2]/div/div[1]/ul/li[1]/a
                        //   /html/body/div[1]/div/div[2]/div/div[2]/div[2]/div[2]/div/div[1]/ul/li[3]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr["+i+"]/td[2]/a"));

                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr["+i+"]/td[2]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        //  /html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr[37]/td[3]
                        //  /html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr[33]/td[3]
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[2]/div/div[2]/div[2]/div/table/tbody/tr["+i+"]/td[3]"));
                        String time = elementTime.getText();
                        try {
                            time = time.replace("[", "");
                            time = time.replace("]", "");
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                        if(!ObjectUtils.isEmpty(href1)){
                            int i1 = href1.indexOf("ggzy.chifeng.gov.cn");
                            if(i1 < 0){
                                String md5idhref1 = DigestUtils.md5DigestAsHex(href1.getBytes());
                                Cfsnmgggzy hhhtsnmgggzy = new Cfsnmgggzy();
                                hhhtsnmgggzy.setId(md5idhref1);
                                hhhtsnmgggzy.setTitle(title);
                                hhhtsnmgggzy.setTime(time);
                                hhhtsnmgggzy.setUrl(href1);
                                hhhtsnmgggzy.setChannle(channle);
                                hhhtsnmgggzy.setContent("链接文章");
                                cfsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                continue;
                            }
                        }
                        if(!ObjectUtils.isEmpty(href1)){
                            String fileType = getFileType(href1);
                            if(fileType == "" || fileType == null || fileType == "null"){
                                fileType = getFileTypeByUrl(href1);
                            }
                            if(!ObjectUtils.isEmpty(fileType) && fileType != null && fileType != ""){
                                if(!ObjectUtils.isEmpty(title)){
                                    String md5idStr = DigestUtils.md5DigestAsHex((href1+time+title).getBytes());
                                    String ff = downLoadFromUrl(href1,title+md5idStr+"."+fileType,JsoupUtilsView.filePathCFS);
                                    if(ff != "" && ff != null && fileType != null && fileType != ""){
                                        Cfsnmgggzy hhhtsnmgggzy = new Cfsnmgggzy();
                                        hhhtsnmgggzy.setId(md5id);
                                        hhhtsnmgggzy.setTitle(title);
                                        hhhtsnmgggzy.setTime(time);
                                        hhhtsnmgggzy.setUrl(title+md5idStr+"."+fileType);
                                        hhhtsnmgggzy.setChannle(channle);
                                        hhhtsnmgggzy.setContent("文件文章");
                                        cfsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                                        continue;
                                    }
                                }
                            }
                        }

                        Cfsnmgggzy hhhtsnmgggzy = new Cfsnmgggzy();
                        hhhtsnmgggzy.setId(md5id);
                        hhhtsnmgggzy.setTitle(title);
                        hhhtsnmgggzy.setTime(time);
                        hhhtsnmgggzy.setUrl(href1);
                        hhhtsnmgggzy.setChannle(channle);
                        cfsnmgggzyService.saveOrUpdate(hhhtsnmgggzy);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }


    public void saveContent(String url){
        QueryWrapper<Cfsnmgggzy> queryWrapper = new QueryWrapper<Cfsnmgggzy>();
        queryWrapper.eq("url", url);

        List<Cfsnmgggzy> list = cfsnmgggzyService.list(queryWrapper);
        for (Cfsnmgggzy hhhtsnmgggzy : list) {
            zyxxCont(hhhtsnmgggzy);
        }
    }

    public void zyxxCont(Cfsnmgggzy hhhtsnmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(hhhtsnmgggzy.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {

                    String baseUrl = jsoupUtils.getBaseUrl(hhhtsnmgggzy.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    Element detail_contect = document.getElementById("contentA");
                    try {
                        Elements tdTitle = document.getElementsByClass("titlestyle");
                        hhhtsnmgggzy.setTitle(tdTitle.text());
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    try {
                        document.getElementsByTag("form").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                    try {
                        document.getElementById("tdTitle").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    try {
                        document.getElementsByClass("mid-content-head").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                    String HTML = detail_contect.html();
                    System.out.println("=======================");
                    System.out.println(HTML);
                    FileStrList fileStrList = jsoupUtilsView.rexStringHtmlCFS(HTML);
                    String html = fileStrList.getHtml();
                    hhhtsnmgggzy.setContent(html);
                    System.out.println("=======================");
                    System.out.println(html);
                    fileStrList.setHtml(html);
                    List<String> fileList = fileStrList.getFileList();
                    String fileIds = "";
                    for (String s : fileList) {
                        fileIds += s +",";
                    }
                    if(fileIds != "" && fileIds != null){
                        hhhtsnmgggzy.setFileIds(fileIds);
                    }
                    List<String> imgList = fileStrList.getImgList();
                    String imgIds = "";
                    for (String s : imgList) {
                        imgIds += s +",";
                    }
                    if(imgIds != "" && imgIds != null){
                        hhhtsnmgggzy.setImageIds(imgIds);
                    }
                    System.out.println("+++++++++++++++++++++++++++++++++++");
                    System.out.println(fileStrList.getHtml());
                    cfsnmgggzyService.updateById(hhhtsnmgggzy);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }

    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }



    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }



    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
}
