package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.Bynrnmgggzy;
import com.example.nmgggzyspyder.entity.SpyderKbsq;
import com.example.nmgggzyspyder.service.BynrnmgggzyService;
import com.example.nmgggzyspyder.service.SpyderKbsqService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class CmsSpyderKbsq {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private BynrnmgggzyService bynrnmgggzyService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private SpyderKbsqService spyderKbsqService;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle,String isClick[]){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            try {
                if(isClick.length > 0){
                    for (String s : isClick) {
                       try {
                           WebElement is = driver.findElement(By.xpath(s));
                           is.click();
                           new WebDriverWait(driver, Duration.ofSeconds(5));
                           Thread.sleep(1700);
                       }catch (Exception e){
                           e.printStackTrace();
                       }
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }
            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.xpath("/html/body/div[3]/div/div[1]/div[3]/div[4]/ul/li[12]/input"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.xpath("/html/body/div[3]/div/div[1]/div[3]/div[4]/ul/li[13]/a"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                    Thread.sleep(2700);
                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 0; i <= 20; i++) {
                    try {

                        try {
                            WebElement elementTitleSpan = driver.findElement(By.xpath("/html/body/div[3]/div/div[1]/div[3]/div[3]/ul/li["+i+"]/div[2]/div/span"));
                            WebElement elementTitleSpanAhref = driver.findElement(By.xpath("/html/body/div[3]/div/div[1]/div[3]/div[3]/ul/li["+i+"]/div[2]/div/div/a[1]"));
                            String textTitleTop = elementTitleSpan.getAttribute("title");
                            try {
                                for (int t = 0; t < 20;t++){
                                    textTitleTop =  textTitleTop.replace("("+t+")", "");
                                }
                            }catch (Exception e){
                                e.printStackTrace();
                            }
                            String hrefTop = elementTitleSpanAhref.getAttribute("href");
                            String idStrTop = textTitleTop + hrefTop;
                            String md5idTop = DigestUtils.md5DigestAsHex(idStrTop.getBytes());

                            SpyderKbsq spyderKbsq = new SpyderKbsq();
                            spyderKbsq.setId(md5idTop);
                            spyderKbsq.setTitle(textTitleTop);
                            spyderKbsq.setUrl(hrefTop);

                            spyderKbsqService.saveOrUpdate(spyderKbsq);

                        }catch (Exception e){
                            e.printStackTrace();
                        }

                        for (int z = 0;z < 10;z++){
                            try {
                                WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[3]/div/div[1]/div[3]/div[3]/ul/li["+i+"]/div[2]/div["+z+"]/span"));
                                WebElement elementAhref = driver.findElement(By.xpath("/html/body/div[3]/div/div[1]/div[3]/div[3]/ul/li["+i+"]/div[2]/div["+z+"]/div/a[1]"));
                                String textTitle = elementTitle.getAttribute("title");
                                try {
                                    for (int t = 0; t < 20;t++){
                                        textTitle =  textTitle.replace("("+t+")", "");
                                    }
                                }catch (Exception e){
                                    e.printStackTrace();
                                }
                                String href = elementAhref.getAttribute("href");
                                String idStr = textTitle + href;
                                String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());
                                SpyderKbsq spyderKbsq = new SpyderKbsq();
                                spyderKbsq.setId(md5id);
                                spyderKbsq.setTitle(textTitle);
                                spyderKbsq.setUrl(href);
                                try {
                                    //  https://zwfw.nmg.gov.cn/handle_affairs_detail?item_detail_id=bb4497468b41840c018b5f64d65e3a25&regionCode=150603000000&highlight=personal
                                    int i1 = href.indexOf("item_detail_id=");
                                    int i2 = href.indexOf("&regionCode=");
                                    String idid = href.substring(i1+15, i2);
                                    spyderKbsq.setIdid(idid);
                                }catch (Exception e){
                                    e.printStackTrace();
                                }
                                spyderKbsqService.saveOrUpdate(spyderKbsq);
                            }catch (Exception e){
                                e.printStackTrace();
                            }
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }

    public void saveContent(String url){
        QueryWrapper<Bynrnmgggzy> queryWrapper = new QueryWrapper<Bynrnmgggzy>();
        queryWrapper.eq("url", url);
        List<Bynrnmgggzy> list = bynrnmgggzyService.list(queryWrapper);
        for (Bynrnmgggzy hhhtsnmgggzy : list) {
            zyxxCont(hhhtsnmgggzy);
        }
    }

    public void zyxxCont(Bynrnmgggzy hhhtsnmgggzy){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(hhhtsnmgggzy.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                String pageSource = driver.getPageSource();
                Document parse = Jsoup.parse(pageSource);
                try {
                    String baseUrl = jsoupUtils.getBaseUrl(hhhtsnmgggzy.getUrl());
                    Document document = jsoupUtils.setUrl(parse, baseUrl);
                    try {
                        document.getElementsByClass("detail-tt").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    try {
                        document.getElementsByClass("detail-info").remove();
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                    Elements elementsByClass = document.getElementsByClass("ewb-list-main");
                    String HTML = elementsByClass.html();
                    System.out.println("=======================");
                    System.out.println(HTML);
                    FileStrList fileStrList = jsoupUtilsView.rexStringHtmlByne(HTML);
                    String html = fileStrList.getHtml();
                    hhhtsnmgggzy.setContent(html);
                    System.out.println("=======================");
                    System.out.println(html);
                    fileStrList.setHtml(html);
                    List<String> fileList = fileStrList.getFileList();
                    String fileIds = "";
                    for (String s : fileList) {
                        fileIds += s +",";
                    }
                    if(fileIds != "" && fileIds != null){
                        hhhtsnmgggzy.setFileIds(fileIds);
                    }
                    List<String> imgList = fileStrList.getImgList();
                    String imgIds = "";
                    for (String s : imgList) {
                        imgIds += s +",";
                    }
                    if(imgIds != "" && imgIds != null){
                        hhhtsnmgggzy.setImageIds(imgIds);
                    }
                    System.out.println("+++++++++++++++++++++++++++++++++++");
                    System.out.println(fileStrList.getHtml());
                    bynrnmgggzyService.updateById(hhhtsnmgggzy);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }catch (Exception e){
                e.printStackTrace();
            }
            try {
                driver.close();
            }catch (Exception e){
                e.printStackTrace();
            }
            try {
                driver.quit();
            }catch (Exception e){
                e.printStackTrace();
            }
        }catch (Exception e){
        }
    }

    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }



    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
}
