package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.CfsMallbox;
import com.example.nmgggzyspyder.entity.Cfsnmgggzy;
import com.example.nmgggzyspyder.entity.HhhtgggzyMallbox;
import com.example.nmgggzyspyder.service.CfsMallboxService;
import com.example.nmgggzyspyder.service.CfsnmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class MallBoxCFSCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private CfsMallboxService cfsMallboxService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);

            for (int j = 1; j <= pageNum; j++) {
                try {
                    if(j != 1){
                        WebElement su = driver.findElement(By.xpath("/html/body/form/div[3]/div/div[2]/font/div/div/table[5]/tbody/tr[1]/td[2]/div/div[2]/a[5]"));
                        su.click();
                        new WebDriverWait(driver, Duration.ofSeconds(5));
                        Thread.sleep(2700);
                    }
                }catch (Exception e){
                    e.printStackTrace();
                }

                for (int i = 1; i <= 40; i++) {
                    try {
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/form/div[3]/div/div[2]/font/div/div/div[1]/table/tbody/tr["+i+"]/td[2]/a"));


                        String onclick = elementTitle.getAttribute("onclick");
                        onclick = onclick.replace("window.open('", "");
                        onclick = onclick.replace("','_blank')", "");

                        String href1 ="http://ggzy.chifeng.gov.cn/EpointWeb_CF/xinxiang/" + onclick;

                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/form/div[3]/div/div[2]/font/div/div/div[1]/table/tbody/tr["+i+"]/td[2]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/form/div[3]/div/div[2]/font/div/div/div[1]/table/tbody/tr["+i+"]/td[3]"));
                        String time = elementTime.getText();

                        System.out.println(time);
                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());

                        CfsMallbox cfsMallbox = new CfsMallbox();
                        cfsMallbox.setId(md5id);
                        cfsMallbox.setTitle(title);
                        cfsMallbox.setReplyTime(time);
                        cfsMallbox.setUrl(href1);
                        cfsMallbox.setChannle(channle);
                        cfsMallboxService.saveOrUpdate(cfsMallbox);

                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }

    public void saveContent(String url){
        QueryWrapper<CfsMallbox> queryWrapper = new QueryWrapper<CfsMallbox>();
        queryWrapper.eq("url", url);
        List<CfsMallbox> list = cfsMallboxService.list(queryWrapper);
        for (CfsMallbox cfsMallbox : list) {
            zyxxCont(cfsMallbox);
        }
    }

    public void zyxxCont(CfsMallbox cfsMallbox){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(cfsMallbox.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                try {
                    WebElement petitionerTime = driver.findElement(By.xpath("/html/body/form/div[3]/div/div[2]/font/div/div/div/div[2]/div/table[1]/tbody/tr[2]/td/table/tbody/tr/td[2]/input"));
                    WebElement petitionerContent = driver.findElement(By.xpath("/html/body/form/div[3]/div/div[2]/font/div/div/div/div[2]/div/table[1]/tbody/tr[3]/td/table/tbody/tr/td[2]"));
                    WebElement replyTime = driver.findElement(By.xpath("/html/body/form/div[3]/div/div[2]/font/div/div/div/div[2]/div/table[1]/tbody/tr[6]/td/table/tbody/tr/td[2]"));
                    WebElement replyContent = driver.findElement(By.xpath("/html/body/form/div[3]/div/div[2]/font/div/div/div/div[2]/div/table[1]/tbody/tr[5]/td/table/tbody/tr/td[2]"));
                    cfsMallbox.setPetitionerName("匿名");
                    cfsMallbox.setPetitionerTime(petitionerTime.getText());
                    cfsMallbox.setPetitionerContent(petitionerContent.getText());
                    cfsMallbox.setReplyTime(replyTime.getText());
                    cfsMallbox.setReplyContent(replyContent.getText());
                    cfsMallboxService.updateById(cfsMallbox);
                }catch (Exception e){
                    e.printStackTrace();
                }

            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }


    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
}
