package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.HhhtgggzyMallbox;
import com.example.nmgggzyspyder.entity.TlsMallbox;
import com.example.nmgggzyspyder.entity.Tlsnmgggzy;
import com.example.nmgggzyspyder.service.TlsMallboxService;
import com.example.nmgggzyspyder.service.TlsnmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class MallBoxTLSrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private TlsMallboxService tlsMallboxService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;

    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);

            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.xpath("/html/body/main/div[2]/div/div[2]/div/div/ul/div/div[2]/div/div[2]/div/input"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.xpath("/html/body/main/div[2]/div/div[2]/div/div/ul/div/div[2]/div/div[2]/div/button"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                    Thread.sleep(2700);
                }catch (Exception e){
                    e.printStackTrace();
                }

                for (int i = 1; i <= 15; i++) {
                    try {                                                    ///html/body/main/div[2]/div/div[2]/div/div/ul/div/div[1]/ul[2]/table/tr[1]/td[4]/a
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/main/div[2]/div/div[2]/div/div/ul/div/div[1]/ul[2]/table/tr["+i+"]/td[4]/a"));

                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/main/div[2]/div/div[2]/div/div/ul/div/div[1]/ul[2]/table/tr["+i+"]/td[4]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/main/div[2]/div/div[2]/div/div/ul/div/div[1]/ul[2]/table/tr["+i+"]/td[5]"));
                        String time = elementTime.getText();
                        System.out.println(time);

                        WebElement elementTime2 = driver.findElement(By.xpath("/html/body/main/div[2]/div/div[2]/div/div/ul/div/div[1]/ul[2]/table/tr["+i+"]/td[6]"));
                        String time2 = elementTime2.getText();
                        System.out.println(time2);

                        String idStr = title + href1 + time + time2 + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());

                        TlsMallbox tlsMallbox = new TlsMallbox();
                        tlsMallbox.setId(md5id);
                        tlsMallbox.setTitle(title);
                        tlsMallbox.setReplyTime(time);
                        tlsMallbox.setPetitionerTime(time2);
                        tlsMallbox.setUrl(href1);
                        tlsMallbox.setChannle(channle);
                        tlsMallboxService.saveOrUpdate(tlsMallbox);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }


    public void saveContent(String url){
        QueryWrapper<TlsMallbox> queryWrapper = new QueryWrapper<TlsMallbox>();
        queryWrapper.eq("url", url);

        List<TlsMallbox> list = tlsMallboxService.list(queryWrapper);
        for (TlsMallbox tlsMallbox : list) {
            zyxxCont(tlsMallbox);
        }
    }

    public void zyxxCont(TlsMallbox tlsMallbox){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(tlsMallbox.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);

                WebElement petitionerTime = driver.findElement(By.xpath("/html/body/div/div[2]/ul/div/div/table/tbody/tr[1]/td[4]/div"));
                WebElement petitionerContent = driver.findElement(By.xpath("/html/body/div/div[2]/ul/div/div/table/tbody/tr[2]/td[2]/div"));
                WebElement replyTime = driver.findElement(By.xpath("/html/body/div/div[2]/ul/div/div/table/tbody/tr[3]/td[2]/div"));
                WebElement replyContent = driver.findElement(By.xpath("/html/body/div/div[2]/ul/div/div/table/tbody/tr[4]/td[2]/div"));
                tlsMallbox.setPetitionerName("匿名");
                tlsMallbox.setPetitionerTime(petitionerTime.getText());
                tlsMallbox.setPetitionerContent(petitionerContent.getText());
                tlsMallbox.setReplyTime(replyTime.getText());
                tlsMallbox.setReplyContent(replyContent.getText());
                tlsMallboxService.updateById(tlsMallbox);

            }catch (Exception e){
            }
            try {
                driver.close();
            }catch (Exception e){
            }
            try {
                driver.quit();
            }catch (Exception e){
            }
        }catch (Exception e){
        }
    }

    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }



    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
}
