package com.example.nmgggzyspyder.spyder;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.nmgggzyspyder.entity.NmgggzyMallbox;
import com.example.nmgggzyspyder.entity.XlglmMallbox;
import com.example.nmgggzyspyder.entity.Xlglmnmgggzy;
import com.example.nmgggzyspyder.service.XlglmMallboxService;
import com.example.nmgggzyspyder.service.XlglmnmgggzyService;
import com.example.nmgggzyspyder.utils.FileStrList;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsView;
import kong.unirest.Unirest;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.DigestUtils;
import org.springframework.util.ObjectUtils;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.time.Duration;
import java.util.List;

@Component
public class MallBoxXLGLMCrawling {

    @Autowired
    private CreateChromeDriver createChromeDriver;

    @Autowired
    private XlglmMallboxService xlglmMallboxService;

    @Autowired
    private JsoupUtilsView jsoupUtilsView;


    @Autowired
    private JsoupUtils jsoupUtils;

    private String scriptStrwebdriver = "window.navigator.webdriver=undefined";

    public void zyxx(String url,int pageNum,String channle){
        RemoteWebDriver driver = createChromeDriver.createChromeDriver();
        try {
            driver.executeScript(scriptStrwebdriver);
            driver.get(url);
            new WebDriverWait(driver, Duration.ofSeconds(5));
            Thread.sleep(1700);
            for (int j = 1; j <= pageNum; j++) {
                try {
                    //在id为kw的输入框当中输入内容
                    WebElement kw = driver.findElement(By.xpath("/html/body/div[4]/div/div[2]/div/div[2]/div/div/input[1]"));
                    kw.clear();
                    kw.sendKeys(j+"");
                    WebElement su = driver.findElement(By.xpath("/html/body/div[4]/div/div[2]/div/div[2]/div/div/input[2]"));
                    su.click();
                    new WebDriverWait(driver, Duration.ofSeconds(5));
                    Thread.sleep(2700);
                }catch (Exception e){
                    e.printStackTrace();
                }
                for (int i = 1; i <= 15; i++) {
                    try {
                        WebElement elementTitle = driver.findElement(By.xpath("/html/body/div[4]/div[2]/div[2]/div/div[2]/div/div/div/form/div/div/div[1]/div["+i+"]/span[1]/a"));

                        String href1 =  elementTitle.getAttribute("href");
                        System.out.println(href1);

                        WebElement elementTimeTitle = driver.findElement(By.xpath("/html/body/div[4]/div[2]/div[2]/div/div[2]/div/div/div/form/div/div/div[1]/div["+i+"]/span[1]/a"));
                        String title = elementTimeTitle.getText();
                        System.out.println(title);
                        WebElement elementTime = driver.findElement(By.xpath("/html/body/div[4]/div[2]/div[2]/div/div[2]/div/div/div/form/div/div/div[1]/div["+i+"]/span[2]"));
                        String time = elementTime.getText();

                        System.out.println(time);

                        String idStr = title + href1 + time + channle;
                        String md5id = DigestUtils.md5DigestAsHex(idStr.getBytes());

                        XlglmMallbox xlglmMallbox = new XlglmMallbox();
                        xlglmMallbox.setId(md5id);
                        xlglmMallbox.setTitle(title);
                        xlglmMallbox.setPetitionerTime(time);
                        xlglmMallbox.setUrl(href1);
                        xlglmMallbox.setChannle(channle);

                        xlglmMallboxService.saveOrUpdate(xlglmMallbox);
                        if(!ObjectUtils.isEmpty(href1)){
                            saveContent(href1);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }

                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            driver.close();
        }catch (Exception e){
        }
        try {
            driver.quit();
        }catch (Exception e){
        }
    }


    public void saveContent(String url){
        QueryWrapper<XlglmMallbox> queryWrapper = new QueryWrapper<XlglmMallbox>();
        queryWrapper.eq("url", url);
        List<XlglmMallbox> list = xlglmMallboxService.list(queryWrapper);
        for (XlglmMallbox xlglmMallbox : list) {
            zyxxCont(xlglmMallbox);
        }
    }

    public void zyxxCont(XlglmMallbox xlglmMallbox){
        try {
            RemoteWebDriver driver = createChromeDriver.createChromeDriver();
            try {
                driver.executeScript(scriptStrwebdriver);
                driver.get(xlglmMallbox.getUrl());
                new WebDriverWait(driver, Duration.ofSeconds(5));
                Thread.sleep(2700);
                WebElement petitionerName = driver.findElement(By.xpath("/html/body/div[4]/div[2]/div[2]/div/div[2]/div/div/div/div/div[2]/div[1]/div"));
                xlglmMallbox.setPetitionerName(petitionerName.getText());
                WebElement petitionerTime = driver.findElement(By.xpath("/html/body/div[4]/div[2]/div[2]/div/div[2]/div/div/div/div/div[2]/div[2]/div"));
                xlglmMallbox.setPetitionerTime(petitionerTime.getText());
                WebElement petitionerContent = driver.findElement(By.xpath("/html/body/div[4]/div[2]/div[2]/div/div[2]/div/div/div/div/div[2]/div[4]/div"));
                xlglmMallbox.setPetitionerContent(petitionerContent.getText());
                WebElement replyUnit = driver.findElement(By.xpath("/html/body/div[4]/div[2]/div[2]/div/div[2]/div/div/div/div/div[2]/div[6]/div"));
                xlglmMallbox.setReplyUnit(replyUnit.getText());
                WebElement replyTime = driver.findElement(By.xpath("/html/body/div[4]/div[2]/div[2]/div/div[2]/div/div/div/div/div[2]/div[7]/div"));
                xlglmMallbox.setReplyTime(replyTime.getText());
                WebElement replyContent = driver.findElement(By.xpath("/html/body/div[4]/div[2]/div[2]/div/div[2]/div/div/div/div/div[2]/div[8]/div"));
                xlglmMallbox.setReplyContent(replyContent.getText());
                xlglmMallboxService.updateById(xlglmMallbox);
            }catch (Exception e){
                e.printStackTrace();
            }
            try {
                driver.close();
            }catch (Exception e){
                e.printStackTrace();
            }
            try {
                driver.quit();
            }catch (Exception e){
                e.printStackTrace();
            }
        }catch (Exception e){
        }
    }

    private String getFileType(String text) {
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

    public  String downLoadFromUrl(String urlStr, String fileName, String savePath) {
        if(urlStr != null && urlStr != "" && urlStr != "null"){
            System.out.println(urlStr);
            System.out.println(fileName);
            System.out.println(savePath);
            try {
                File result = Unirest.get(urlStr)
                        .asFile(savePath+fileName)
                        .getBody();
                return fileName;
            }catch (Exception e){
                return null;
            }
        }
        return null;
    }
    private String getFileTypeByUrl(String urlStr) {
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
        }catch (Exception e){

        }
        if(ObjectUtils.isEmpty(text)){
            return null;
        }
        String suffixes="avi,mpeg,3gp,mp3,mp4,wav,jpeg,gif,jpg,png,apk,exe,pdf,rar,zip,docx,doc,txt,xls,rar,ppt,XLS,RAR,PDF," +
                "AVI,MPEG,3GP,MP3,MP4,WAV,JPEG,GIF,JPG,PNG,APK,EXE,PDF,RAR,ZIP,DOCX,DOC,TXT,XLS,RAR,PPT,XLS,RAR,PDF,PPT,XLSX,xlsx,docx"
                ;
        String[] split = suffixes.split(",");
        String type = null;
        for (String st : split) {
            int i = text.indexOf(st);
            if(i >=0){
                type = st;
            }
        }
        return type;
    }

}
