package com.example.nmgggzyspyder;

import com.example.nmgggzyspyder.es.HyZc;
import com.example.nmgggzyspyder.es.HyZcMysqlModel;
import com.example.nmgggzyspyder.es.UpdateEsTongliao;
import com.example.nmgggzyspyder.service.HyZcMysqlModelService;
import com.example.nmgggzyspyder.spyder.*;
import com.example.nmgggzyspyder.utils.JsoupUtils;
import com.example.nmgggzyspyder.utils.JsoupUtilsViewTls;
import kong.unirest.HttpResponse;
import kong.unirest.JsonNode;
import kong.unirest.Unirest;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@SpringBootTest
class NmgggzyspyderApplicationTests {

    @Autowired
    private CmsCrawling cmsCrawling;

    @Autowired
    private CmsHHHTCrawling cmsHHHTCrawling;

    @Autowired
    private CmsBaoTouShiCrawling cmsBaoTouShiCrawling;

    @Autowired
    private CmsEEDSCrawling cmsEEDSCrawling;

    @Autowired
    private CmshlbeggzyjyCrawling cmshlbeggzyjyCrawling;

    @Autowired
    private CmsXLGLMCrawling cmsXLGLMCrawling;

    @Autowired
    private CmsWHSCrawling cmsWHSCrawling;

    @Autowired
    private CmsCFSCrawling cmsCFSCrawling;

    @Autowired
    private CmsWLCBrawling cmsWLCBrawling;

    @Autowired
    private CmsTLSrawling cmsTLSrawling;

    @Autowired
    private CmsByerrawling cmsByerrawling;

    @Autowired
    private CmsALSCawling cmsALSCawling;

    @Autowired
    private CmsXAMrawling cmsXAMrawling;

    @Autowired
    private CmsSpyderKbsq cmsSpyderKbsq;


    @Autowired
    private JsoupUtils jsoupUtils111;

    @Autowired
    private MallBoxCrawling mallBoxCrawling;

    @Autowired
    private MallBoxCmsHHHTCrawling mallBoxCmsHHHTCrawling;

    @Autowired
    private MallBoxXLGLMCrawling mallBoxXLGLMCrawling;

    @Autowired
    private MallBoxCFSCrawling mallBoxCFSCrawling;

    @Autowired
    private MallBoxTLSrawling mallBoxTLSrawling;

    @Autowired
    private MallBoxALSrawling mallBoxALSrawling;

    @Autowired
    private MallBoxhlbeggzyjyCrawling mallBoxhlbeggzyjyCrawling;

    @Autowired
    private MallBoxXAMCrawling mallBoxXAMCrawling;

    @Autowired
    private MallBoxByzeCrawling mallBoxByzeCrawling;

    @Autowired
    private CmsMALCrawling cmsMALCrawling;

    @Autowired
    private TouTiaoCawling touTiaoCawling;

    @Test
    void test11111(){
        touTiaoCawling.login();
    }


    @Test
    void hhhtTets(){
        cmsHHHTCrawling.zyxx("https://ggzy.huhhot.gov.cn/zwdt/toutiao/",110,"首页/政务动态/头条/头条");
    }

    @Test
    void contextLoads222() {



      //  cmsMALCrawling.zyxx("http://www.mzlggzy.org.cn/notice/index.htm","http://www.mzlggzy.org.cn/notice/index_", 8,"首页/中心动态/中心动态");
        cmsMALCrawling.zyxx("http://www.mzlggzy.org.cn/yhys/index.htm","http://www.mzlggzy.org.cn/yhys/index_", 3,"首页/满洲里专栏/满洲里专栏");
       // cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003001/notice.html", 8,"首页/政策法规/公共资源");
        ////cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003002/notice.html", 8,"首页/政策法规/建设工程");
        // cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003003/notice.html", 9,"首页/政策法规/政府采购");
        // cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003004/notice.html", 4,"首页/政策法规/自然资源");
        //  cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003005/notice.html", 1,"首页/政策法规/产权交易");

    }

    @Test
    void contextLoads111111() {
        mallBoxCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/flfg_cf/002005/", 20,"首页/法律法规/公共资源交易相关法律和政策");
        mallBoxCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/flfg_cf/002006/", 1,"首页/法律法规/法律");
    }
    @Test
    void contextLoads2222() {
        mallBoxCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/flfg_cf/002007/", 10,"首页/法律法规/法规");
        mallBoxCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/flfg_cf/002008/", 10,"首页/法律法规/规范性文件");
    }

    @Test
    void countContentBox(){
         mallBoxCrawling.zyxx("https://ggzyjy.nmg.gov.cn/hdjl/dMailBox/dMailBox", 4,"主任信箱");
         mallBoxCrawling.zyxx("https://ggzyjy.nmg.gov.cn/hdjl/workJL/workJL", 3,"工作交流");
         mallBoxCrawling.zyxx("https://ggzyjy.nmg.gov.cn/hdjl/complaintConsultation/complaintConsultation", 3,"咨询投诉");
         mallBoxCmsHHHTCrawling.zyxx("http://ggzy.huhhot.gov.cn/hdjl/ldxx/xjgs/", 2,"信件公示");
         mallBoxCmsHHHTCrawling.zyxx("http://ggzy.huhhot.gov.cn/hdjl/ldxx/xjgs/", 2,"信件公示");
         mallBoxXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/hdzq/gzly/lygs/index.html", 1,"信件公示");
         mallBoxXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/hdzq/gzly/lycx/index.html", 1,"留言查询");
         mallBoxXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/hdzq/gzly/lytj/index.html", 1,"留言统计");
         mallBoxCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/xinxiang/XinXiList.aspx?XjType=11&BoxGroupID=f466f7cd-1da1-47df-88ee-b6db3ce78bc2#", 1,"信件查询");
         mallBoxXAMCrawling.zyxx("https://www.xamggzyjyzx.org.cn/zxts/019001/tipoff.html", 2,"投诉举报");
         mallBoxXAMCrawling.zyxx("https://www.xamggzyjyzx.org.cn/zxts/019002/tipoff2.html", 2,"建议留言");
         mallBoxByzeCrawling.zyxx("http://ggzyjy.bynr.gov.cn/wsdy/wsdy.html", 16,"建设工程");
         cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ztzl/016005/notice2.html", 5,"优化营商环境");
         cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ztzl/016005/016005001/notice2.html", 2,"政策法规");
         cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ztzl/016005/016005003/notice2.html", 2,"营商动态");
         cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ztzl/016005/016005002/notice2.html", 3,"他山之石");
         cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ztzl/016003/notice2.html", 2,"网络安全");
         cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ztzl/016003/016003001/notice2.html", 1,"网安法实施五年来");
         cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ztzl/016003/016003002/notice2.html", 1,"相关案例");
         cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/index/xyxx/index.html", 2,"信用信息");
         cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/index/tszs/index.html", 2,"他山之石");
         cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/index/jzzm/index.html", 2,"警钟长鸣");
    }

    @Test
    void contextLoads1100() {
       // cmsCrawling.zyxx("https://ggzyjy.nmg.gov.cn/newsInfo/getWorkNewsList", 2,"工作动态");
        cmsCrawling.spyderJSON();
    }

    @Test
    void contextLoads11() {
        cmsCrawling.zyxx("https://ggzyjy.nmg.gov.cn/newsInfo/getInfoNewsList", 20,"重要信息");
        cmsCrawling.zyxx("https://ggzyjy.nmg.gov.cn/newsInfo/mszx", 35,"盟市动态");
        cmsCrawling.zyxx("https://ggzyjy.nmg.gov.cn/newsInfo/getWorkNewsList", 26,"工作动态");
        cmsCrawling.zyxx("https://ggzyjy.nmg.gov.cn/newsInfo/yhyshj", 1,"优化营商环境");
    }

    @Test
    void contextLoads() {
         // cmsCrawling.zyxx("https://ggzyjy.nmg.gov.cn/centerAll/openWork?type=4", 2,"政务公开/管理制度");
         // cmsCrawling.zyxx("https://ggzyjy.nmg.gov.cn/centerAll/openWork?type=3", 4,"财务公开");
         // cmsCrawling.zyxx("https://ggzyjy.nmg.gov.cn/centerAll/openWork?type=2", 2,"政务公开/人事任免");
         // cmsCrawling.zyxx("https://ggzyjy.nmg.gov.cn/checkBulletin/list", 5,"政务公开/考核通报");
         // cmsCrawling.zcfg("https://ggzyjy.nmg.gov.cn/jyzk/zcfg?zcfgType=2", 5,2,"政策法规/公共资源交易");
         // cmsCrawling.zcfg("https://ggzyjy.nmg.gov.cn/jyzk/zcfg?zcfgType=3", 2,1,"政策法规/政府采购");
         // cmsCrawling.zcfg("https://ggzyjy.nmg.gov.cn/jyzk/zcfg?zcfgType=4", 2,1,"政策法规/工程建设");
         // cmsCrawling.zcfg("https://ggzyjy.nmg.gov.cn/jyzk/zcfg?zcfgType=5", 1,1,"政策法规/土地矿权交易");
         // cmsCrawling.zcfg("https://ggzyjy.nmg.gov.cn/jyzk/zcfg?zcfgType=6", 1,1,"政策法规/产权交易");
         // cmsCrawling.zcfgOn("https://ggzyjy.nmg.gov.cn/jyzk/zcfg?type2=3", 5,"政策法规/盟市级");
         // cmsCrawling.zcfgOn("https://ggzyjy.nmg.gov.cn/jyzk/zcjd", 3,"政策法规/政策解读");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/fwzn/fwqd", 3,"服务指南/服务清单");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/fwzn/fwlc", 3,"服务指南/交易流程");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/fwzn/jyml", 3,"服务指南/交易目录");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/fwzn/cjwt", 3,"服务指南/常见问题");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/fwzn/fwzn", 3,"服务指南/投标指南");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/jyzk/zycd", 3,"服务指南/专业词典");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/jyzk/zbal", 3,"服务指南/招标案例");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/jyzk/sfwb", 3,"服务指南/示范文本");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/jyzk/pbbf", 3,"服务指南/评标办法");
         // cmsCrawling.zyxxPT("https://ggzyjy.nmg.gov.cn/jyzk/pbbf", 3,"服务指南/盟市指引");
         // cmsCrawling.zcfgOn("https://ggzyjy.nmg.gov.cn/jyzk/zcfg?type2=3", 5,"政策法规/盟市级");
          cmsCrawling.zyxxDJGZ("https://ggzyjy.nmg.gov.cn/jyzk/zcfg?type2=3", 5,"政策法规/盟市级");

    }

    @Test
    void contextLoadsContent() {
        cmsHHHTCrawling.zyxxDL("https://ggzyjy.nmg.gov.cn/nmgggfwpt-center-web/login",11,"优化营商环境优化营商环境");
        //cmsHHHTCrawling.zwgg("http://ggzy.huhhot.gov.cn/zwdt/gzdt/",1,"政务动态/工作动态");
        //cmsHHHTCrawling.zwgg("http://ggzy.huhhot.gov.cn/zwdt/tpxw/",1,"政务动态/图片新闻");
        //cmsHHHTCrawling.zwggZWDT("http://ggzy.huhhot.gov.cn/zwdt/toutiao/",10,"政务动态/头条");
        //cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/lqhm/",1,"利企惠民");
        //cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/yhyshj/ywdt/",4,"优化营商环境");

    }

    @Test
    void contextLoadsContent11() {
 /*        cmsHHHTCrawling.zwgg("http://ggzy.huhhot.gov.cn/zwdt/gzdt/",1,"政务动态/工作动态");
         cmsHHHTCrawling.zwgg("http://ggzy.huhhot.gov.cn/zwdt/tpxw/",1,"政务动态/图片新闻");
         cmsHHHTCrawling.zwgg("http://ggzy.huhhot.gov.cn/zwdt/tpxw/",1,"政务动态/图片新闻");
         cmsHHHTCrawling.zwggZWDT("http://ggzy.huhhot.gov.cn/zwdt/toutiao/",10,"政务动态/头条");
         cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/tzgg/",1,"政务公开/通知公告");
         cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/dwjj/",1,"政务公开/单位简介");
         cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/glzd/",3,"政务公开/管理制度");
         */
       // cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/swgk/",3,"政务公开/政务公开/政务公开");
        cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/zcwj/",7,"政务公开/政策文件/政策文件/政策文件");
         cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/zcjd/",1,"政务公开/政策解读/政策解读/政策解读");
         /* cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/wznb/",1,"政务公开/政府网站年报");
         cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/jyta/",1,"政务公开/建议提案");
         cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/zdlyxxgk/",2,"政务公开/重点领域信息公开");
         cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/ldzc/",1,"领导之窗");
         cmsHHHTCrawling.zwgg("https://ggzy.huhhot.gov.cn/zwgk/dwgk/",2,"党务公开");
         cmsHHHTCrawling.zwggIP("http://42.123.92.182:9010/jgxx/008006/infoList.html",4,"监管信息");
         cmsHHHTCrawling.zwggIP("http://42.123.92.182:9010/jyzn/003001/infoList.html",2,"交易指南");
         cmsHHHTCrawling.zwggIP("http://42.123.92.182:9010/jyzn/003007/infoList.html",3,"操作手册");
         cmsHHHTCrawling.zwggIP("http://42.123.92.182:9010/jyzn/003005/infoList.html",1,"下载中心");*/
    }

    @Test
    void contextLoadsContentBtggzynew() {
         cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/tzgg/notice.html",3,"通知公告");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ddjs/001001/notice.html",3,"专题学习");
    }
    @Test
    void contextLoadsContentBtggzynew23322() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003003/notice.html",3,"政策法规/政府采购");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/gzdt/notice.html",3,"工作动态");
    }

    @Test
    void contextLoadsContentBtggzynew222() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/tzgg/notice.html",4,"通知公告");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ddjs/001003/notice.html",3,"党风廉政建设");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ddjs/001004/notice.html",1,"中华文化符号和形象");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ddjs/001005/notice.html",1,"铸牢中华民族共同体意识");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zwgk/002001/notice.html",1,"政务公开/中心简介");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zwgk/002008/notice.html",1,"政务公开/政府信息公开指南");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zwgk/002002/notice.html",1,"政务公开/领导成员");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zwgk/002003/notice.html",1,"政务公开/组织架构");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zwgk/002004/notice.html",1,"政务公开/联系方式");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zwgk/002006/notice.html",1,"政务公开/职能清单");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zwgk/002007/notice.html",1,"政务公开/预决算公开");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003001/notice.html",7,"政策法规/公共资源");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003002/notice.html",7,"政策法规/建设工程");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003004/notice.html",3,"政策法规/自然资源");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zcfg/003005/notice.html",1,"政策法规/产权交易");
    }

    @Test
    void contextLoadsContentBtggzynew1111() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/bszn/004001/notice.html",2,"办事指南/下载中心");
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/ddjs/001002/notice.html",2,"党建要闻");
    }
    @Test
    void contextLoadsContentBtggzynew1112() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/bszn/004002/notice.html",2,"办事指南/建设工程");
    }
    @Test
    void contextLoadsContentBtggzynew1113() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/bszn/004003/notice.html",1,"办事指南/政府采购");
    }
        @Test
    void contextLoadsContentBtggzynew1114() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/bszn/004004/notice.html",1,"办事指南/自然资源");
    }
    @Test
    void contextLoadsContentBtggzynew1115() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/bszn/004005/notice.html",1,"办事指南/产权交易");
    }


    @Test
    void contextLoadsContentBtggzynew111511() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zwgk/002007/notice.html",3,"首页/政务公开/预决算公开");
    }

    @Test
    void contextLoadsContentBtggzynew111511222() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/zwgk/002006/notice.html",1,"首页/政务公开/职能清单");
    }

    @Test
    void contextLoadsContentBtggzynew1117() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/bszn/004006/notice.html",1,"办事指南/CA在线办理");
    }
    @Test
    void contextLoadsContentBtggzynew1118() {
        cmsBaoTouShiCrawling.zyxx("https://www.btggzyjy.cn/bszn/004007/notice.html",1,"办事指南/投诉渠道");
    }
    @Test
    void dow000(){
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/djgz/033004/subpage.html", "https://www.hlbeggzyjy.org.cn/djgz/033004/",10,"首页/党建工作党建工作/意识形态");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/djgz/033004/subpage.html", "https://www.hlbeggzyjy.org.cn/djgz/033004/",10,"首页/党建工作党建工作/意识形态");

    }

    @Test
    void dow0001111111(){
       // cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/xyxx/004006/subpage.html", "https://www.hlbeggzyjy.org.cn/xyxx/004006/",1,"首页/信用信息/行政处罚");
       // cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/xyxx/004010/subpage.html", "https://www.hlbeggzyjy.org.cn/xyxx/004010/",1,"首页/信用信息/信用规定");
       // cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/xyxx/004011/subpage.html", "https://www.hlbeggzyjy.org.cn/xyxx/004011/",1,"首页/信用平台/双随机一公开");
      //  cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/xyxx/004012/subpage.html", "https://www.hlbeggzyjy.org.cn/xyxx/004012/",1,"首页/信用信息/代理机构信用评价");

        cmshlbeggzyjyCrawling.zyxxHY("https://www.hlbeggzyjy.org.cn/yhyshjzl/034003/business_column.html", "https://www.hlbeggzyjy.org.cn/yhyshjzl/034003/",10,"首页/优化营商环境专栏/业务动态/业务动态");
        cmshlbeggzyjyCrawling.zyxxHY("https://www.hlbeggzyjy.org.cn/yhyshjzl/034006/business_column.html", "https://www.hlbeggzyjy.org.cn/yhyshjzl/034006/",1,"首页/优化营商环境专栏/典型案例/典型案例");

    }

    @Test
    void dow2121(){
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/dtxw/subpage.html", "https://www.hlbeggzyjy.org.cn/dtxw/",2,"动态新闻");
    }

    @Test
    void dowHLBE000() {
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/tzgg/subpage.html", "http://www.hlbeggzyjy.org.cn/tzgg/",2,"通知公告");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/dtxw/subpage.html", "https://www.hlbeggzyjy.org.cn/dtxw/",2,"动态新闻");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xzzx/007001/subpage.html", "http://www.hlbeggzyjy.org.cn/xzzx/007001/",1,"交易发起方");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xzzx/007002/subpage.html", "http://www.hlbeggzyjy.org.cn/xzzx/007002/",1,"交易响应方");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xzzx/007003/subpage.html", "http://www.hlbeggzyjy.org.cn/xzzx/007003/",1,"代理机构");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004006/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004006/",1,"行政处罚");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004007/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004007/",1,"不规范行为披露");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004010/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004010/",1,"信用规定");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004011/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004011/",1,"双随机一公开");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004012/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004012/",1,"代理机构信用评价");

    }

    @Test
    void dowHLBE0001() {
        cmshlbeggzyjyCrawling.zyxxHY("https://www.hlbeggzyjy.org.cn/yhyshjzl/034005/business_column.html", "https://www.hlbeggzyjy.org.cn/yhyshjzl/034005/",3,"首页/优化营商环境专栏/国家政策");
        cmshlbeggzyjyCrawling.zyxxHY("https://www.hlbeggzyjy.org.cn/yhyshjzl/034001/business_column.html", "https://www.hlbeggzyjy.org.cn/yhyshjzl/034001/",1,"首页优化营商环境专栏内蒙古自治区政策");
        cmshlbeggzyjyCrawling.zyxxHY("https://www.hlbeggzyjy.org.cn/yhyshjzl/034002/business_column.html", "https://www.hlbeggzyjy.org.cn/yhyshjzl/034002/",2,"首页优化营商环境专栏呼伦贝尔市政策");

        cmshlbeggzyjyCrawling.zyxxHY("https://www.hlbeggzyjy.org.cn/yhyshjzl/034003/business_column.html", "https://www.hlbeggzyjy.org.cn/yhyshjzl/034003/",10,"首页优化营商环境专栏业务动态");
        cmshlbeggzyjyCrawling.zyxxHY("https://www.hlbeggzyjy.org.cn/yhyshjzl/034006/business_column.html", "https://www.hlbeggzyjy.org.cn/yhyshjzl/034006/",1,"首页优化营商环境专栏典型案例");
        cmshlbeggzyjyCrawling.zyxxHY("https://www.hlbeggzyjy.org.cn/yhyshjzl/034004/business_column.html", "https://www.hlbeggzyjy.org.cn/yhyshjzl/034004/",1,"首页优化营商环境专栏问卷调查");

    }



    @Test
    void dowHLBE() {
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/dtxw/subpage.html", "http://www.hlbeggzyjy.org.cn/dtxw/",3,"动态新闻");
    }

    @Test
    void dowHLBE2() {
         cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/tzgg/subpage.html", "http://www.hlbeggzyjy.org.cn/tzgg/",3,"通知公告");
         cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xzzx/007001/subpage.html", "http://www.hlbeggzyjy.org.cn/xzzx/007001/",1,"交易发起方");
         cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xzzx/007002/subpage.html", "http://www.hlbeggzyjy.org.cn/xzzx/007002/",1,"交易响应方");
         cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xzzx/007003/subpage.html", "http://www.hlbeggzyjy.org.cn/xzzx/007003/",1,"代理机构");
         cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004006/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004006/",1,"行政处罚");
         cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004007/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004007/",1,"不规范行为披露");
         cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004010/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004010/",1,"信用规定");
         cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004011/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004011/",1,"双随机一公开");
         cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xyxx/004012/subpage.html", "http://www.hlbeggzyjy.org.cn/xyxx/004012/",1,"代理机构信用评价");

    }

    @Test
    void dowHLBE3() {
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/djgz/033001/subpage.html", "http://www.hlbeggzyjy.org.cn/djgz/033001/",3,"党建工作/党建动态");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/djgz/033002/subpage.html", "http://www.hlbeggzyjy.org.cn/djgz/033002/",1,"党建工作/党史教育");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/djgz/033003/subpage.html", "http://www.hlbeggzyjy.org.cn/djgz/033003/",1,"党建工作/三会一课");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/djgz/033004/subpage.html", "http://www.hlbeggzyjy.org.cn/djgz/033004/",1,"党建工作/意识形态");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/djgz/033005/subpage.html", "http://www.hlbeggzyjy.org.cn/djgz/033005/",1,"党建工作/党风廉政建设");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/djgz/033006/subpage.html", "http://www.hlbeggzyjy.org.cn/djgz/033006/",1,"党建工作/其他工作");
    }
    @Test
    void dowHLBE4() {
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/zwxx/002001/policy_public.html", "http://www.hlbeggzyjy.org.cn/zwxx/002001/",2,"政务公开/信息公开制度");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/zwxx/002002/policy_public.html", "http://www.hlbeggzyjy.org.cn/zwxx/002002/",1,"政务公开/信息公开指南");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/zwxx/002003/policy_public.html", "http://www.hlbeggzyjy.org.cn/zwxx/002003/",1,"政务公开/信息公开目录");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/zwxx/002004/policy_public.html", "http://www.hlbeggzyjy.org.cn/zwxx/002004/",1,"政务公开/信息公开年度报告");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/zwxx/002005/policy_public.html", "http://www.hlbeggzyjy.org.cn/zwxx/002005/",1,"政务公开/信息依申请公开");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/zwxx/002006/policy_public.html", "http://www.hlbeggzyjy.org.cn/zwxx/002006/",2,"政务公开/信息依申请公开");
    }
    @Test
    void dowHLBE45() {
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/bszn/005003/list.html", "https://www.xamggzyjyzx.org.cn/bszn/005003/",2,"办事指南/操作手册");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/zwgk/002001/list.html", "https://www.xamggzyjyzx.org.cn/zwgk/002001/",8,"政务公开/工作动态");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/zwgk/002009/list.html", "https://www.xamggzyjyzx.org.cn/zwgk/002009/",6,"政务公开/工作动态");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/zwgk/002007/", "https://www.xamggzyjyzx.org.cn/zwgk/002007/",2,"政务公开/预决算公开");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/zwgk/002007/list.html", "https://www.xamggzyjyzx.org.cn/zwgk/002007/",2,"政务公开/制度建设");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/djzl/004007/list.html", "https://www.xamggzyjyzx.org.cn/djzl/004007/",1,"政务公开/主题教育");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/djzl/004001/list.html", "https://www.xamggzyjyzx.org.cn/djzl/004001/",6,"政务公开/主题教育");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/djzl/004006/list.html", "https://www.xamggzyjyzx.org.cn/djzl/004006/",1,"政务公开/主题教育");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/djzl/004006/list.html", "https://www.xamggzyjyzx.org.cn/djzl/004006/",1,"政务公开/主题教育");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/djzl/004004/list.html", "https://www.xamggzyjyzx.org.cn/djzl/004004/",2,"政务公开/党史学习教育");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/djzl/004005/list.html", "https://www.xamggzyjyzx.org.cn/djzl/004005/",1,"政务公开/党史学习教育");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/djzl/004003/list.html", "https://www.xamggzyjyzx.org.cn/djzl/004003/",1,"政务公开/主题党日专栏");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/qyxx/016004/list.html", "https://www.xamggzyjyzx.org.cn/qyxx/016004/",1,"信用信息/不规范行为");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/bszn/005002/list.html", "https://www.xamggzyjyzx.org.cn/bszn/005002/",2,"办事指南/交易流程");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/bszn/005003/list.html", "https://www.xamggzyjyzx.org.cn/bszn/005003/",2,"办事指南/操作手册");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/bszn/005003/list.html", "https://www.xamggzyjyzx.org.cn/bszn/005003/",2,"办事指南/操作手册");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/zcfg/list.html", "https://www.xamggzyjyzx.org.cn/zcfg/",4,"政策法规");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/zwgk/002002/list.html", "https://www.xamggzyjyzx.org.cn/zwgk/002002/",9,"政务公开/通知公告");
        cmsXAMrawling.zyxx("https://www.xamggzyjyzx.org.cn/zwgk/002009/list.html", "https://www.xamggzyjyzx.org.cn/zwgk/002009/",6,"优化营商环境");
    }

    @Test
    void dowHLBE5() {
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/fwzn/003003/subpage.html", "http://www.hlbeggzyjy.org.cn/fwzn/003003/",1,"服务指南/业务指南");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xzzx/007006/subpage.html", "http://www.hlbeggzyjy.org.cn/xzzx/007006/",1,"下载中心/常用表单");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/xzzx/policy_public.html", "http://www.hlbeggzyjy.org.cn/xzzx/",1,"下载中心/下载中心");
        cmshlbeggzyjyCrawling.zyxx("http://www.hlbeggzyjy.org.cn/zcfg/subpage.html", "http://www.hlbeggzyjy.org.cn/zcfg/",1,"政策法规/政策法规");
    }

    @Test
    void dowHLBE566() {
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011001/011001001/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011001/011001001/",1,"首页/政策法规/工程建设/法律");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011001/011001002/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011001/011001002/",1,"首页/政策法规/工程建设/法规");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011001/011001003/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011001/011001003/",3,"首页/政策法规/工程建设/规章");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011001/011001004/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011001/011001004/",2,"首页/政策法规/工程建设/规范性文件");

        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011002/011002001/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011002/011002001/",1,"首页/政策法规/政府采购/法律");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011002/011002002/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011002/011002002/",1,"首页/政策法规/政府采购/法规");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011002/011002003/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011002/011002003/",1,"首页/政策法规/政府采购/规章");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011002/011002004/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011002/011002004/",1,"首页/政策法规/政府采购/规范性文件");

        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011003/011003001/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011002/011002001/",1,"首页/政策法规/土地使用权/法律");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011003/011003002/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011003/011003002/",1,"首页/政策法规/土地使用权/法规");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011003/011003003/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011003/011003003/",1,"首页/政策法规/土地使用权/规章");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011003/011003004/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011003/011003004/",1,"首页/政策法规/土地使用权/规范性文件");

        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011004/011004001/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011004/011004001/",1,"首页/政策法规/矿业权/法律");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011004/011004002/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011004/011004002/",1,"首页/政策法规/矿业权/法规");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011004/011004004/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011004/011004004/",1,"首页/政策法规/矿业权/规范性文件");

        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011005/011005001/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011005/011005001/",1,"首页/政策法规/国有产权/法律");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011005/011005002/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011005/011005002/",1,"首页/政策法规/国有产权/法规");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011005/011005003/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011005/011005003/",1,"首页/政策法规/国有产权/规章");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011005/011005004/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011005/011005004/",1,"首页/政策法规/国有产权/规范性文件");

        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011006/011006001/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011006/011006001/",1,"首页/政策法规/权益类交易/法律");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011006/011006002/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011006/011006002/",1,"首页/政策法规/权益类交易/法规");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011006/011006003/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011006/011006003/",1,"首页/政策法规/权益类交易/规章");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011006/011006004/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011006/011006004/",1,"首页/政策法规/权益类交易/规范性文件");

        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011007/011007001/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011007/011007001/",1,"首页/政策法规/权益类交易/法律");
        cmshlbeggzyjyCrawling.zyxx("https://www.hlbeggzyjy.org.cn/zcfg/011007/011007002/subpage.html", "https://www.hlbeggzyjy.org.cn/zcfg/011007/011007002/",1,"首页/政策法规/权益类交易/法规");


    }

    @Test
    void dow() {
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/zwgk/glzd/index.html", 2,"中心简介/管理制度");
        /*cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/index/gzdt/index.html", 19,"工作动态");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/index/tzgg/index.html", 31,"通知公告");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/djgz/djdt/index.html", 10,"党建动态");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/fwzn/wytb/index.html", 1,"我要投标");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/fwzn/cafw/index.html", 2,"CA服务");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/fwzn/cabl/index.html", 1,"CA服务");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/fwzn/qzqd/index.html", 1,"权责清单");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/fwzn/wyzb/index.html", 1,"我要招标");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/fwzn/wytb/index.html", 1,"我要招标");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/fwzn/pszj/index.html", 1,"我要招标");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/fwzn/pszj/index.html", 1,"我要招标");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/xxzl/xtkj/index.html", 1,"我要招标");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/xxzl/xtkj/index.html", 1,"我要招标");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/xxzl/xtkj/index.html", 3,"政策法规/国家级");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/xxzl/xtkj/index.html", 3,"政策法规/自治区级");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/xxzl/xtkj/index.html", 3,"政策法规/盟本级");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/eportal/ui?pageId=f91b7f6d4c3942f2ac0904ed91396efb", 3,"学习贯彻党的二十大精神专栏");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/eportal/ui?pageId=24ac3b048cf441939f64608a8daa5a80", 3,"学党史 悟思想 办实事 开新局");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/eportal/ui?pageId=5e800b9ef3ac4e5ebc3f04e7383fc8b7", 5,"铸牢中华民族共同体意识促进民族团结进步专栏");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/eportal/ui?pageId=cd4e77b529864fd5a75a8d7dc264c6b0", 12,"优化营商环境服务专栏");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/eportal/ui?pageId=d46147011d87405aba46419925219574", 1,"万众一心 共同抗疫 守护我们的城市");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/eportal/ui?pageId=d46147011d87405aba46419925219574", 1,"学习贯彻习近平新时代中国特色社会主义思想主题教育");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/djgz/gzzd/index.html", 2,"规章制度");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/zcfg/gjj/index.html", 3,"政策法规/国家级");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/zcfg/zzqj/index.html", 3,"政策法规/自治区级");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/zcfg/mbj/index.html", 3,"政策法规/盟本级");
        cmsXLGLMCrawling.zyxx("http://www.xmggzyjy.org.cn/xmggzyjy/zcfg/mbj/index.html", 3,"政策法规/盟本级");*/
    }

    /////////////////////////////////////////////////////////////////////////////////
    @Test
    void dowWH() {

       String click[] = {
               ""
       };
        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?isStick=true&parentId=65999&childrenCode=ImportantNotice&utm=luban.luban-PC-49434.1069-pc-wsg-ArticlePurchaseNoticeList-front.1.c6dc2e8068d711eeb84413df52224b10", 1,"重要通知",click);
        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?isStick=true&parentId=65999&childrenCode=ImportantNotice&utm=luban.luban-PC-49434.1069-pc-wsg-ArticlePurchaseNoticeList-front.1.c6dc2e8068d711eeb84413df52224b10", 5,"重要通知",click);
        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=65999&childrenCode=WorkDynamics&utm=luban.luban-PC-49434.1069-pc-wsg-ArticlePurchaseNoticeList-front.1.c03608f068da11ee88f081ac834991cf", 6,"工作动态",click);
        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66028&childrenCode=MembershipNotes&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.8.255d44a068db11ee82d7f51ea3b30e01", 1,"会员须知",click);
        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66025&childrenCode=PartyConstruction&utm=luban.luban-PC-49434.1069-pc-wsg-ArticlePurchaseNoticeList-front.1.8c08613068db11eeb25991e9db27988d", 2,"党建专栏/党建专栏",click);
        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66014&childrenCode=CahandlingGuide&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.5.c6d7b2f079f411ee86a88de9a97eeaa9", 1,
                "建设交易指南",click);

        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66014&childrenCode=CahandlingGuide&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.5.c6d7b2f079f411ee86a88de9a97eeaa9", 1,

                        "政府采购指南",click);

        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66014&childrenCode=CahandlingGuide&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.5.c6d7b2f079f411ee86a88de9a97eeaa9", 1,

                        "政府采购指南",click);

        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66014&childrenCode=CahandlingGuide&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.5.c6d7b2f079f411ee86a88de9a97eeaa9", 1,
                "综合交易指南",click);

        cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66007&childrenCode=PoliciesAndRegulations&utm=luban.luban-PC-49436.959-pc-websitegroup-navBar-front.4.69d87800829b11eea8d957376a42e711", 6,
                "公共资源交易",click);
    }
    @Test
    void dowWH11() {
        //cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=65999&childrenCode=PurchaseAdvisory&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.2.52df2310582a11ee8382e56faacbe2f1", 3,"采购资讯/网站头条");

        String click[] = {

        };
        // cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?isStick=true&parentId=65999&childrenCode=ImportantNotice&utm=luban.luban-PC-49434.1069-pc-wsg-ArticlePurchaseNoticeList-front.1.c6dc2e8068d711eeb84413df52224b10", 1,"重要通知",click);
         cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=65999&childrenCode=WorkDynamics&utm=luban.luban-PC-49434.1069-pc-wsg-ArticlePurchaseNoticeList-front.1.c03608f068da11ee88f081ac834991cf", 6,"工作动态",click);
        //  cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66028&childrenCode=MembershipNotes&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.8.255d44a068db11ee82d7f51ea3b30e01", 1,"会员须知",click);
         // cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66025&childrenCode=PartyConstruction&utm=luban.luban-PC-49434.1069-pc-wsg-ArticlePurchaseNoticeList-front.1.8c08613068db11eeb25991e9db27988d", 2,"党建专栏/党建专栏",click);
       // cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66003&childrenCode=AnnualReport&utm=luban.luban-PC-49436.959-pc-websitegroup-navBar-front.3.127f8390697911ee95a591001ec2eedc", 1,"管理制度",click);
        //cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=190168&childrenCode=wuhaiCategory1&utm=luban.luban-PC-49436.959-pc-websitegroup-navBar-front.9.1e0905b0699711eea3c54fcb0fb7238d", 2,"市场主体",click);
       // cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=190168&childrenCode=wuhaiCategory1&utm=luban.luban-PC-49436.959-pc-websitegroup-navBar-front.9.1e0905b0699711eea3c54fcb0fb7238d", 1,"曝光台",click);
      //  cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66025&childrenCode=PartyConstruction&utm=luban.luban-PC-49436.959-pc-websitegroup-navBar-front.7.7e13f020699a11eea3ade9dcb6ce93a5", 5,"党建专栏/党建专栏",click);
       // cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66015&childrenCode=DownloadZone&utm=luban.luban-PC-49436.959-pc-websitegroup-navBar-front.6.808cb850699a11ee8fb7ef33fb363e13", 1,"使用手册",click);
        // cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66015&childrenCode=DownloadZone&utm=luban.luban-PC-49436.959-pc-websitegroup-navBar-front.6.808cb850699a11ee8fb7ef33fb363e13", 1,"投标工具",click);
        // cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?isStick=true&parentId=65999&childrenCode=ImportantNotice&utm=luban.luban-PC-49434.1069-pc-wsg-ArticlePurchaseNoticeList-front.1.f26d38107a1511ee9f989dbfe1d79015", 2,"优化营商环境专栏",click);
        //cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?isStick=true&parentId=65999&childrenCode=ImportantNotice&utm=luban.luban-PC-49434.1069-pc-wsg-ArticlePurchaseNoticeList-front.1.f26d38107a1511ee9f989dbfe1d79015", 2,"优化营商环境专栏",click);
        //  cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66014&childrenCode=CahandlingGuide&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.5.c6d7b2f079f411ee86a88de9a97eeaa9", 1,"ca办理指南",click);
         //cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66014&childrenCode=CahandlingGuide&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.5.c6d7b2f079f411ee86a88de9a97eeaa9", 1,"建设交易指南",click);
        // cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66014&childrenCode=CahandlingGuide&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.5.c6d7b2f079f411ee86a88de9a97eeaa9", 1,"国土交易指南",click);
        // cmsWHSCrawling.zyxx("http://www.whggzy.com/luban/category?parentId=66014&childrenCode=CahandlingGuide&utm=luban.luban-PC-49434.959-pc-websitegroup-navBar-front.5.c6d7b2f079f411ee86a88de9a97eeaa9", 1,"综合交易指南",click);

    }

    @Test
    void dowCF() {
       String click[] = {
       };
         cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/tzgg_cf/", 1,"通知公告",click);
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/zwgk_cf/001002/", 1,"政务公开/政务动态",click);
    }
    @Test
    void dowCF111() {

       String click[] = {
       };
         cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/tzgg_cf/", 16,"通知公告",click);
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/zwgk_cf/001002/", 8,"政务公开/政务动态",click);
    }
    @Test
    void dowCF111111() {
       String click[] = {
       };
       cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/tzgg_cf/", 1,"通知公告",click);
    }

    @Test
    void dowCF111222() {
       String click[] = {
       };
       cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/tzgg_cf/", 1,"通知公告",click);
       cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/zwgk_cf/001001/", 1,"政务公开/中心简介",click);
       cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/zwgk_cf/001003/", 1,"政务公开/机构职能",click);
       cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/jgjj_cf/004001/", 1,"党建工作/工作动态",click);
    }

    @Test
    void dowCF11122233() {
        String click[] = {
        };
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/jgjj_cf/004003/", 1,"党建工作/教育学习",click);
    }
    @Test
    void dowCF1112223344() {
        String click[] = {
        };
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/jgjj_cf/004002/", 2,"党建工作/制度建设",click);
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/zwgk_cf/001004/", 1,"党建工作/工作流程",click);
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/cygj_cf/013002/", 1,"常用工具/培训视频下载",click);
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/cygj_cf/013002/", 1,"常用工具/培训视频下载",click);
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/cygj_cf/013003/", 1,"常用工具/常用工具下载",click);
    }
    @Test
    void dowCF111222334455() {
        String click[] = {
        };
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/flfg_cf/002005/", 1,"法律法规/公共资源交易相关法律和政策",click);
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/flfg_cf/002006/", 1,"法律法规/法律",click);
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/flfg_cf/002007/", 1,"法律法规/法规",click);
        cmsCFSCrawling.zyxx("http://ggzy.chifeng.gov.cn/EpointWeb_CF/flfg_cf/002008/", 1,"法律法规/规范性文件",click);
    }

    @Test
    void dowCF111222334455111() {
        String click[] = {
        };
        cmsCFSCrawling.zyxxPage("http://ggzy.chifeng.gov.cn/EpointWeb_CF/flfg_cf/002005/?Paging=", 1,"法律法规/公共资源交易相关法律和政策",click);
    }

    @Test
    void dowWLCB2222222222() {
        String click[] = {
        };
        cmsWLCBrawling.zyxx("http://ggzy.wulanchabu.gov.cn/zcfg/009001/bid_plan.html", 3,"首页/政策法规/综合",click);
        cmsWLCBrawling.zyxx("http://ggzy.wulanchabu.gov.cn/zcfg/009002/bid_plan.html", 3,"首页/政策法规/政策解读",click);
        cmsWLCBrawling.zyxx("http://ggzy.wulanchabu.gov.cn/zcfg/009003/bid_plan.html", 3,"首页/政策法规/政府采购",click);
        cmsWLCBrawling.zyxx("http://ggzy.wulanchabu.gov.cn/zcfg/009004/bid_plan.html", 3,"首页/政策法规/工程建设",click);
        cmsWLCBrawling.zyxx("http://ggzy.wulanchabu.gov.cn/zcfg/009005/bid_plan.html", 3,"首页/政策法规/土地/矿业权",click);
        cmsWLCBrawling.zyxx("http://ggzy.wulanchabu.gov.cn/zcfg/009006/bid_plan.html", 3,"首页/政策法规/国有产权",click);
    }

    @Test
    void dowWLCB() {
       String click[] = {
       };
         cmsWLCBrawling.zyxx("http://ggzy.wulanchabu.gov.cn/tzgg/bid_plan.html", 1,"通知公告",click);
         cmsWLCBrawling.zyxx("http://ggzy.wulanchabu.gov.cn/dtyw/bid_plan.html", 1,"动态要闻",click);
    }


    @Test
    void dowTLS() {
       String click[] = {
       };
        cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/tzgg/about.html", 1,"通知公告",click);
        cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/tzgg/about.html", 1,"工作动态",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/jyxw/about.html", 1,"中心动态",click);
          cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001007/001007010/about.html", 2,"主题教育",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001007/001007002/about.html", 1,"政策法规小讲堂",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001007/001007007/about.html", 1,"民族团结进步",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001007/001007009/about.html", 1,"网络安全",click);
    }
    @Test
    void dowTLS2() {
       String click[] = {
       };
       // cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/tzgg/about.html", 14,"通知公告",click);
       // cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/jyxw/about.html", 68,"中心动态",click);
        cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/qsqj/about.html", 10,"旗市区级",click);
    }
    @Test
    void dowTLS3() {
         String click[] = {

         };
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001001/about.html", 1,"政务公开/中心简介",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001003/about.html", 1,"政务公开/内设机构",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001010/about.html", 1,"政务公开/财务公开",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001002/about.html", 1,"政务公开/中心职能",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001004/about.html", 5,"政务公开/党建工作",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001005/about.html", 1,"政务公开/廉政专栏",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zxgk/001009/about.html", 3,"政务公开/交易监管",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/bszn/003008/about.html", 2,"办事指南/交易课堂",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/xzzx/about.html", 2,"下载中心",click);
         //cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zcfg/zcfg.html#", 22,"政策法规/综合类",click);
         cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zcfg/zcfg.html#", 10,"政策法规/综合类",click);
    }
    @Test
    void dowTLS33() {
        String click[] = {
                "/html/body/div[2]/div/div[2]/div[1]/div[2]/ul/li[5]/h3/a",
                "/html/body/div[2]/div/div[2]/div[2]/div[2]/div[1]/div[2]/a[2]"
        };
        cmsTLSrawling.zyxx("https://ggzy.tongliao.gov.cn/tlsggzy/zcfg/zcfg.html#", 1,"政策法规/国有产权/政策文件",click);
    }

    @Test
    void dowByne() {
       String click[] = {
       };
        cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/tzgg/moreinfo.html", 14,"通知公告",click);
        cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/zwxx/moreinfo.html", 1,"中心动态",click);
        cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/bszn/moreinfo.html", 1,"办事指南",click);
    }
    @Test
    void dowByne22() {
        String click[] = {
        };
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/tzgg/moreinfo.html", 1,"通知公告",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/zwxx/moreinfo.html", 1,"中心动态",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/zwgk/032003/moreinfo.html", 1,"政务公开/机构设置",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/zwgk/032006/moreinfo.html", 1,"政务公开/政务公开",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/zwgk/032007/moreinfo.html", 1,"政务公开/财务公开",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/jygk/moreinfo.html", 1,"交易公开",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/djzl/moreinfo.html", 3,"党建专栏",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/yshj/moreinfo.html", 3,"营商环境",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/jgxx/moreinfo.html", 1,"监管信息",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/xzzx/moreinfo.html", 2,"下载中心",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/bszn/moreinfo.html", 2,"办事指南",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/bszn/moreinfo.html", 2,"办事指南",click);
         cmsByerrawling.zyxx("http://ggzyjy.bynr.gov.cn/zcfg/moreinfo.html", 3,"政策法规",click);
    }

    @Test
    void dowcmsALSCawling() {
        cmsALSCawling.zyxx(
                "http://www.alsggzyjy.cn/PublicServer/publicAnnouncement/getList.do",
                "152900",
                1,
                18,
                "06",
                "1",
                "首页/政策法规/建设工程",
                5
        );
    }

    @Test
    void dowtest11111(){

        HttpResponse<JsonNode> response = Unirest.post("http://www.alsggzyjy.cn/PublicServer/publicAnnouncement/getList.do")
                .header("accept", "application/json")
                .queryString("areaCode", "152900")
                .queryString("page", "2")
                .queryString("rows", "18")
                .queryString("colType", "colType")
                .asJson();
    }

    @Test
    void testTest(){
        String urlStr = "http://www.alsggzyjy.cn/doFile/download/?attachmentId=9F2C97FA-ECCE-4823-9575-781CD91E150A";
        String text = null;
        try {
            URL url = new URL(urlStr);
            URLConnection conn = url.openConnection();
            String fileName = conn.getHeaderField("Content-Disposition"); // 获取文件名
            text = fileName;
            System.out.println(text);
        }catch (Exception e){
        }
    }


    @Autowired
    private UpdateEsTongliao updateEsTongliao;

    @Test
    void testTestTLSJYJ(){
        List<HyZcMysqlModel> hyZcMysqlModels = updateEsTongliao.getHyZcMysqlModelList("4b5fc6664e454d56a1cb770799fc60ea", "https://jyj.tongliao.gov.cn/");
        for (HyZcMysqlModel hyZcMysqlModel : hyZcMysqlModels) {
            System.out.println(hyZcMysqlModel);
            HyZc hyZc = new HyZc(hyZcMysqlModel,14165,8,"通辽市教育局","通辽市教育局本地同步文章");
            updateEsTongliao.updateES(hyZc);
            System.out.println(hyZc);
        }
    }

    @Test
    void testTestGYHXXHJ(){
        List<HyZcMysqlModel> hyZcMysqlModels = updateEsTongliao.getHyZcMysqlModelList("4b5fc6664e454d56a1cb770799fc60ea", "https://jyj.tongliao.gov.cn/");
        for (HyZcMysqlModel hyZcMysqlModel : hyZcMysqlModels) {
            System.out.println(hyZcMysqlModel);
            HyZc hyZc = new HyZc(hyZcMysqlModel,14165,8,"通辽市工业和信息化局","通辽市工业和信息化局本地同步文章");
            updateEsTongliao.updateES(hyZc);
            System.out.println(hyZc);
        }
    }

    @Test
    void test0001(){
        String href =  "https://zwfw.nmg.gov.cn/handle_affairs_detail?item_detail_id=bb4497468b41840c018b5f64d65e3a25&regionCode=150603000000&highlight=personal";
        int i1 = href.indexOf("item_detail_id=");
        int i2 = href.indexOf("&regionCode=");
        String idid = href.substring(i1+15, i2);
        System.out.println(idid);
    }
    @Test
    void CmsSpyderKbsqTest(){
        String click[] = {
        };
        cmsSpyderKbsq.zyxx("https://zwfw.nmg.gov.cn/handle_affairs?regionCode=150603000000&workType=personal", 50,"通知公告",click);
    }
}
